// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"log"
	"regexp"

	hcl "github.com/hashicorp/hcl/v2"
	"github.com/terraform-linters/tflint/tflint"
)

// AwsAcmCertificateInvalidPrivateKeyRule checks the pattern is valid
type AwsAcmCertificateInvalidPrivateKeyRule struct {
	resourceType  string
	attributeName string
	max           int
	min           int
	pattern       *regexp.Regexp
}

// NewAwsAcmCertificateInvalidPrivateKeyRule returns new rule with default attributes
func NewAwsAcmCertificateInvalidPrivateKeyRule() *AwsAcmCertificateInvalidPrivateKeyRule {
	return &AwsAcmCertificateInvalidPrivateKeyRule{
		resourceType:  "aws_acm_certificate",
		attributeName: "private_key",
		max:           524288,
		min:           1,
		pattern:       regexp.MustCompile(`^-{5}BEGIN PRIVATE KEY-{5}\x{000D}?\x{000A}([A-Za-z0-9/+]{64}\x{000D}?\x{000A})*[A-Za-z0-9/+]{1,64}={0,2}\x{000D}?\x{000A}-{5}END PRIVATE KEY-{5}(\x{000D}?\x{000A})?$`),
	}
}

// Name returns the rule name
func (r *AwsAcmCertificateInvalidPrivateKeyRule) Name() string {
	return "aws_acm_certificate_invalid_private_key"
}

// Enabled returns whether the rule is enabled by default
func (r *AwsAcmCertificateInvalidPrivateKeyRule) Enabled() bool {
	return true
}

// Severity returns the rule severity
func (r *AwsAcmCertificateInvalidPrivateKeyRule) Severity() string {
	return tflint.ERROR
}

// Link returns the rule reference link
func (r *AwsAcmCertificateInvalidPrivateKeyRule) Link() string {
	return ""
}

// Check checks the pattern is valid
func (r *AwsAcmCertificateInvalidPrivateKeyRule) Check(runner *tflint.Runner) error {
	log.Printf("[TRACE] Check `%s` rule for `%s` runner", r.Name(), runner.TFConfigPath())

	return runner.WalkResourceAttributes(r.resourceType, r.attributeName, func(attribute *hcl.Attribute) error {
		var val string
		err := runner.EvaluateExpr(attribute.Expr, &val)

		return runner.EnsureNoError(err, func() error {
			if len(val) > r.max {
				runner.EmitIssue(
					r,
					"private_key must be 524288 characters or less",
					attribute.Expr.Range(),
				)
			}
			if len(val) < r.min {
				runner.EmitIssue(
					r,
					"private_key must be 1 characters or higher",
					attribute.Expr.Range(),
				)
			}
			if !r.pattern.MatchString(val) {
				runner.EmitIssue(
					r,
					`private_key does not match valid pattern ^-{5}BEGIN PRIVATE KEY-{5}\x{000D}?\x{000A}([A-Za-z0-9/+]{64}\x{000D}?\x{000A})*[A-Za-z0-9/+]{1,64}={0,2}\x{000D}?\x{000A}-{5}END PRIVATE KEY-{5}(\x{000D}?\x{000A})?$`,
					attribute.Expr.Range(),
				)
			}
			return nil
		})
	})
}
