// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"testing"

	"github.com/terraform-linters/tflint/tflint"
)

func Test_AwsAMIInvalidArchitectureRule(t *testing.T) {
	cases := []struct {
		Name     string
		Content  string
		Expected tflint.Issues
	}{
		{
			Name: "It includes invalid characters",
			Content: `
resource "aws_ami" "foo" {
	architecture = "x86"
}`,
			Expected: tflint.Issues{
				{
					Rule:    NewAwsAMIInvalidArchitectureRule(),
					Message: `"x86" is an invalid value as architecture`,
				},
			},
		},
		{
			Name: "It is valid",
			Content: `
resource "aws_ami" "foo" {
	architecture = "x86_64"
}`,
			Expected: tflint.Issues{},
		},
	}

	rule := NewAwsAMIInvalidArchitectureRule()

	for _, tc := range cases {
		runner := tflint.TestRunner(t, map[string]string{"resource.tf": tc.Content})

		if err := rule.Check(runner); err != nil {
			t.Fatalf("Unexpected error occurred: %s", err)
		}

		tflint.AssertIssuesWithoutRange(t, tc.Expected, runner.Issues)
	}
}
