// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"testing"

	"github.com/terraform-linters/tflint/tflint"
)

func Test_AwsAPIGatewayGatewayResponseInvalidStatusCodeRule(t *testing.T) {
	cases := []struct {
		Name     string
		Content  string
		Expected tflint.Issues
	}{
		{
			Name: "It includes invalid characters",
			Content: `
resource "aws_api_gateway_gateway_response" "foo" {
	status_code = "004"
}`,
			Expected: tflint.Issues{
				{
					Rule:    NewAwsAPIGatewayGatewayResponseInvalidStatusCodeRule(),
					Message: `"004" does not match valid pattern ^[1-5]\d\d$`,
				},
			},
		},
		{
			Name: "It is valid",
			Content: `
resource "aws_api_gateway_gateway_response" "foo" {
	status_code = "200"
}`,
			Expected: tflint.Issues{},
		},
	}

	rule := NewAwsAPIGatewayGatewayResponseInvalidStatusCodeRule()

	for _, tc := range cases {
		runner := tflint.TestRunner(t, map[string]string{"resource.tf": tc.Content})

		if err := rule.Check(runner); err != nil {
			t.Fatalf("Unexpected error occurred: %s", err)
		}

		tflint.AssertIssuesWithoutRange(t, tc.Expected, runner.Issues)
	}
}
