// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"testing"

	"github.com/terraform-linters/tflint/tflint"
)

func Test_AwsAPIGatewayIntegrationInvalidContentHandlingRule(t *testing.T) {
	cases := []struct {
		Name     string
		Content  string
		Expected tflint.Issues
	}{
		{
			Name: "It includes invalid characters",
			Content: `
resource "aws_api_gateway_integration" "foo" {
	content_handling = "CONVERT_TO_FILE"
}`,
			Expected: tflint.Issues{
				{
					Rule:    NewAwsAPIGatewayIntegrationInvalidContentHandlingRule(),
					Message: `"CONVERT_TO_FILE" is an invalid value as content_handling`,
				},
			},
		},
		{
			Name: "It is valid",
			Content: `
resource "aws_api_gateway_integration" "foo" {
	content_handling = "CONVERT_TO_BINARY"
}`,
			Expected: tflint.Issues{},
		},
	}

	rule := NewAwsAPIGatewayIntegrationInvalidContentHandlingRule()

	for _, tc := range cases {
		runner := tflint.TestRunner(t, map[string]string{"resource.tf": tc.Content})

		if err := rule.Check(runner); err != nil {
			t.Fatalf("Unexpected error occurred: %s", err)
		}

		tflint.AssertIssuesWithoutRange(t, tc.Expected, runner.Issues)
	}
}
