// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"testing"

	"github.com/terraform-linters/tflint/tflint"
)

func Test_AwsAPIGatewayRestAPIInvalidAPIKeySourceRule(t *testing.T) {
	cases := []struct {
		Name     string
		Content  string
		Expected tflint.Issues
	}{
		{
			Name: "It includes invalid characters",
			Content: `
resource "aws_api_gateway_rest_api" "foo" {
	api_key_source = "BODY"
}`,
			Expected: tflint.Issues{
				{
					Rule:    NewAwsAPIGatewayRestAPIInvalidAPIKeySourceRule(),
					Message: `"BODY" is an invalid value as api_key_source`,
				},
			},
		},
		{
			Name: "It is valid",
			Content: `
resource "aws_api_gateway_rest_api" "foo" {
	api_key_source = "AUTHORIZER"
}`,
			Expected: tflint.Issues{},
		},
	}

	rule := NewAwsAPIGatewayRestAPIInvalidAPIKeySourceRule()

	for _, tc := range cases {
		runner := tflint.TestRunner(t, map[string]string{"resource.tf": tc.Content})

		if err := rule.Check(runner); err != nil {
			t.Fatalf("Unexpected error occurred: %s", err)
		}

		tflint.AssertIssuesWithoutRange(t, tc.Expected, runner.Issues)
	}
}
