// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"fmt"
	"log"

	hcl "github.com/hashicorp/hcl/v2"
	"github.com/terraform-linters/tflint/tflint"
)

// AwsAPIGatewayStageInvalidCacheClusterSizeRule checks the pattern is valid
type AwsAPIGatewayStageInvalidCacheClusterSizeRule struct {
	resourceType  string
	attributeName string
	enum          []string
}

// NewAwsAPIGatewayStageInvalidCacheClusterSizeRule returns new rule with default attributes
func NewAwsAPIGatewayStageInvalidCacheClusterSizeRule() *AwsAPIGatewayStageInvalidCacheClusterSizeRule {
	return &AwsAPIGatewayStageInvalidCacheClusterSizeRule{
		resourceType:  "aws_api_gateway_stage",
		attributeName: "cache_cluster_size",
		enum: []string{
			"0.5",
			"1.6",
			"6.1",
			"13.5",
			"28.4",
			"58.2",
			"118",
			"237",
		},
	}
}

// Name returns the rule name
func (r *AwsAPIGatewayStageInvalidCacheClusterSizeRule) Name() string {
	return "aws_api_gateway_stage_invalid_cache_cluster_size"
}

// Enabled returns whether the rule is enabled by default
func (r *AwsAPIGatewayStageInvalidCacheClusterSizeRule) Enabled() bool {
	return true
}

// Severity returns the rule severity
func (r *AwsAPIGatewayStageInvalidCacheClusterSizeRule) Severity() string {
	return tflint.ERROR
}

// Link returns the rule reference link
func (r *AwsAPIGatewayStageInvalidCacheClusterSizeRule) Link() string {
	return ""
}

// Check checks the pattern is valid
func (r *AwsAPIGatewayStageInvalidCacheClusterSizeRule) Check(runner *tflint.Runner) error {
	log.Printf("[TRACE] Check `%s` rule for `%s` runner", r.Name(), runner.TFConfigPath())

	return runner.WalkResourceAttributes(r.resourceType, r.attributeName, func(attribute *hcl.Attribute) error {
		var val string
		err := runner.EvaluateExpr(attribute.Expr, &val)

		return runner.EnsureNoError(err, func() error {
			found := false
			for _, item := range r.enum {
				if item == val {
					found = true
				}
			}
			if !found {
				runner.EmitIssue(
					r,
					fmt.Sprintf(`"%s" is an invalid value as cache_cluster_size`, truncateLongMessage(val)),
					attribute.Expr.Range(),
				)
			}
			return nil
		})
	})
}
