// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"testing"

	"github.com/terraform-linters/tflint/tflint"
)

func Test_AwsAPIGatewayStageInvalidCacheClusterSizeRule(t *testing.T) {
	cases := []struct {
		Name     string
		Content  string
		Expected tflint.Issues
	}{
		{
			Name: "It includes invalid characters",
			Content: `
resource "aws_api_gateway_stage" "foo" {
	cache_cluster_size = "6.2"
}`,
			Expected: tflint.Issues{
				{
					Rule:    NewAwsAPIGatewayStageInvalidCacheClusterSizeRule(),
					Message: `"6.2" is an invalid value as cache_cluster_size`,
				},
			},
		},
		{
			Name: "It is valid",
			Content: `
resource "aws_api_gateway_stage" "foo" {
	cache_cluster_size = "6.1"
}`,
			Expected: tflint.Issues{},
		},
	}

	rule := NewAwsAPIGatewayStageInvalidCacheClusterSizeRule()

	for _, tc := range cases {
		runner := tflint.TestRunner(t, map[string]string{"resource.tf": tc.Content})

		if err := rule.Check(runner); err != nil {
			t.Fatalf("Unexpected error occurred: %s", err)
		}

		tflint.AssertIssuesWithoutRange(t, tc.Expected, runner.Issues)
	}
}
