// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"testing"

	"github.com/terraform-linters/tflint/tflint"
)

func Test_AwsAppautoscalingPolicyInvalidScalableDimensionRule(t *testing.T) {
	cases := []struct {
		Name     string
		Content  string
		Expected tflint.Issues
	}{
		{
			Name: "It includes invalid characters",
			Content: `
resource "aws_appautoscaling_policy" "foo" {
	scalable_dimension = "ecs:service:DesireCount"
}`,
			Expected: tflint.Issues{
				{
					Rule:    NewAwsAppautoscalingPolicyInvalidScalableDimensionRule(),
					Message: `"ecs:service:DesireCount" is an invalid value as scalable_dimension`,
				},
			},
		},
		{
			Name: "It is valid",
			Content: `
resource "aws_appautoscaling_policy" "foo" {
	scalable_dimension = "ecs:service:DesiredCount"
}`,
			Expected: tflint.Issues{},
		},
	}

	rule := NewAwsAppautoscalingPolicyInvalidScalableDimensionRule()

	for _, tc := range cases {
		runner := tflint.TestRunner(t, map[string]string{"resource.tf": tc.Content})

		if err := rule.Check(runner); err != nil {
			t.Fatalf("Unexpected error occurred: %s", err)
		}

		tflint.AssertIssuesWithoutRange(t, tc.Expected, runner.Issues)
	}
}
