// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"fmt"
	"log"

	hcl "github.com/hashicorp/hcl/v2"
	"github.com/terraform-linters/tflint/tflint"
)

// AwsAppautoscalingTargetInvalidServiceNamespaceRule checks the pattern is valid
type AwsAppautoscalingTargetInvalidServiceNamespaceRule struct {
	resourceType  string
	attributeName string
	enum          []string
}

// NewAwsAppautoscalingTargetInvalidServiceNamespaceRule returns new rule with default attributes
func NewAwsAppautoscalingTargetInvalidServiceNamespaceRule() *AwsAppautoscalingTargetInvalidServiceNamespaceRule {
	return &AwsAppautoscalingTargetInvalidServiceNamespaceRule{
		resourceType:  "aws_appautoscaling_target",
		attributeName: "service_namespace",
		enum: []string{
			"ecs",
			"elasticmapreduce",
			"ec2",
			"appstream",
			"dynamodb",
			"rds",
			"sagemaker",
			"custom-resource",
			"comprehend",
			"lambda",
			"cassandra",
			"kafka",
		},
	}
}

// Name returns the rule name
func (r *AwsAppautoscalingTargetInvalidServiceNamespaceRule) Name() string {
	return "aws_appautoscaling_target_invalid_service_namespace"
}

// Enabled returns whether the rule is enabled by default
func (r *AwsAppautoscalingTargetInvalidServiceNamespaceRule) Enabled() bool {
	return true
}

// Severity returns the rule severity
func (r *AwsAppautoscalingTargetInvalidServiceNamespaceRule) Severity() string {
	return tflint.ERROR
}

// Link returns the rule reference link
func (r *AwsAppautoscalingTargetInvalidServiceNamespaceRule) Link() string {
	return ""
}

// Check checks the pattern is valid
func (r *AwsAppautoscalingTargetInvalidServiceNamespaceRule) Check(runner *tflint.Runner) error {
	log.Printf("[TRACE] Check `%s` rule for `%s` runner", r.Name(), runner.TFConfigPath())

	return runner.WalkResourceAttributes(r.resourceType, r.attributeName, func(attribute *hcl.Attribute) error {
		var val string
		err := runner.EvaluateExpr(attribute.Expr, &val)

		return runner.EnsureNoError(err, func() error {
			found := false
			for _, item := range r.enum {
				if item == val {
					found = true
				}
			}
			if !found {
				runner.EmitIssue(
					r,
					fmt.Sprintf(`"%s" is an invalid value as service_namespace`, truncateLongMessage(val)),
					attribute.Expr.Range(),
				)
			}
			return nil
		})
	})
}
