// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"testing"

	"github.com/terraform-linters/tflint/tflint"
)

func Test_AwsAppsyncDatasourceInvalidNameRule(t *testing.T) {
	cases := []struct {
		Name     string
		Content  string
		Expected tflint.Issues
	}{
		{
			Name: "It includes invalid characters",
			Content: `
resource "aws_appsync_datasource" "foo" {
	name = "01_tf_example"
}`,
			Expected: tflint.Issues{
				{
					Rule:    NewAwsAppsyncDatasourceInvalidNameRule(),
					Message: `"01_tf_example" does not match valid pattern ^[_A-Za-z][_0-9A-Za-z]*$`,
				},
			},
		},
		{
			Name: "It is valid",
			Content: `
resource "aws_appsync_datasource" "foo" {
	name = "tf_appsync_example"
}`,
			Expected: tflint.Issues{},
		},
	}

	rule := NewAwsAppsyncDatasourceInvalidNameRule()

	for _, tc := range cases {
		runner := tflint.TestRunner(t, map[string]string{"resource.tf": tc.Content})

		if err := rule.Check(runner); err != nil {
			t.Fatalf("Unexpected error occurred: %s", err)
		}

		tflint.AssertIssuesWithoutRange(t, tc.Expected, runner.Issues)
	}
}
