// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"testing"

	"github.com/terraform-linters/tflint/tflint"
)

func Test_AwsBackupVaultInvalidNameRule(t *testing.T) {
	cases := []struct {
		Name     string
		Content  string
		Expected tflint.Issues
	}{
		{
			Name: "It includes invalid characters",
			Content: `
resource "aws_backup_vault" "foo" {
	name = "example_backup_vault_example_backup_vault_example_backup_vault"
}`,
			Expected: tflint.Issues{
				{
					Rule:    NewAwsBackupVaultInvalidNameRule(),
					Message: `"example_backup_vault_example_backup_vault_example_backup_vault" does not match valid pattern ^[a-zA-Z0-9\-\_]{2,50}$`,
				},
			},
		},
		{
			Name: "It is valid",
			Content: `
resource "aws_backup_vault" "foo" {
	name = "example_backup_vault"
}`,
			Expected: tflint.Issues{},
		},
	}

	rule := NewAwsBackupVaultInvalidNameRule()

	for _, tc := range cases {
		runner := tflint.TestRunner(t, map[string]string{"resource.tf": tc.Content})

		if err := rule.Check(runner); err != nil {
			t.Fatalf("Unexpected error occurred: %s", err)
		}

		tflint.AssertIssuesWithoutRange(t, tc.Expected, runner.Issues)
	}
}
