// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"testing"

	"github.com/terraform-linters/tflint/tflint"
)

func Test_AwsBatchJobQueueInvalidStateRule(t *testing.T) {
	cases := []struct {
		Name     string
		Content  string
		Expected tflint.Issues
	}{
		{
			Name: "It includes invalid characters",
			Content: `
resource "aws_batch_job_queue" "foo" {
	state = "ON"
}`,
			Expected: tflint.Issues{
				{
					Rule:    NewAwsBatchJobQueueInvalidStateRule(),
					Message: `"ON" is an invalid value as state`,
				},
			},
		},
		{
			Name: "It is valid",
			Content: `
resource "aws_batch_job_queue" "foo" {
	state = "ENABLED"
}`,
			Expected: tflint.Issues{},
		},
	}

	rule := NewAwsBatchJobQueueInvalidStateRule()

	for _, tc := range cases {
		runner := tflint.TestRunner(t, map[string]string{"resource.tf": tc.Content})

		if err := rule.Check(runner); err != nil {
			t.Fatalf("Unexpected error occurred: %s", err)
		}

		tflint.AssertIssuesWithoutRange(t, tc.Expected, runner.Issues)
	}
}
