// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"fmt"
	"log"
	"regexp"

	hcl "github.com/hashicorp/hcl/v2"
	"github.com/terraform-linters/tflint/tflint"
)

// AwsCloud9EnvironmentEc2InvalidInstanceTypeRule checks the pattern is valid
type AwsCloud9EnvironmentEc2InvalidInstanceTypeRule struct {
	resourceType  string
	attributeName string
	max           int
	min           int
	pattern       *regexp.Regexp
}

// NewAwsCloud9EnvironmentEc2InvalidInstanceTypeRule returns new rule with default attributes
func NewAwsCloud9EnvironmentEc2InvalidInstanceTypeRule() *AwsCloud9EnvironmentEc2InvalidInstanceTypeRule {
	return &AwsCloud9EnvironmentEc2InvalidInstanceTypeRule{
		resourceType:  "aws_cloud9_environment_ec2",
		attributeName: "instance_type",
		max:           20,
		min:           5,
		pattern:       regexp.MustCompile(`^[a-z][1-9][.][a-z0-9]+$`),
	}
}

// Name returns the rule name
func (r *AwsCloud9EnvironmentEc2InvalidInstanceTypeRule) Name() string {
	return "aws_cloud9_environment_ec2_invalid_instance_type"
}

// Enabled returns whether the rule is enabled by default
func (r *AwsCloud9EnvironmentEc2InvalidInstanceTypeRule) Enabled() bool {
	return true
}

// Severity returns the rule severity
func (r *AwsCloud9EnvironmentEc2InvalidInstanceTypeRule) Severity() string {
	return tflint.ERROR
}

// Link returns the rule reference link
func (r *AwsCloud9EnvironmentEc2InvalidInstanceTypeRule) Link() string {
	return ""
}

// Check checks the pattern is valid
func (r *AwsCloud9EnvironmentEc2InvalidInstanceTypeRule) Check(runner *tflint.Runner) error {
	log.Printf("[TRACE] Check `%s` rule for `%s` runner", r.Name(), runner.TFConfigPath())

	return runner.WalkResourceAttributes(r.resourceType, r.attributeName, func(attribute *hcl.Attribute) error {
		var val string
		err := runner.EvaluateExpr(attribute.Expr, &val)

		return runner.EnsureNoError(err, func() error {
			if len(val) > r.max {
				runner.EmitIssue(
					r,
					"instance_type must be 20 characters or less",
					attribute.Expr.Range(),
				)
			}
			if len(val) < r.min {
				runner.EmitIssue(
					r,
					"instance_type must be 5 characters or higher",
					attribute.Expr.Range(),
				)
			}
			if !r.pattern.MatchString(val) {
				runner.EmitIssue(
					r,
					fmt.Sprintf(`"%s" does not match valid pattern %s`, truncateLongMessage(val), `^[a-z][1-9][.][a-z0-9]+$`),
					attribute.Expr.Range(),
				)
			}
			return nil
		})
	})
}
