// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"testing"

	"github.com/terraform-linters/tflint/tflint"
)

func Test_AwsCloud9EnvironmentEc2InvalidInstanceTypeRule(t *testing.T) {
	cases := []struct {
		Name     string
		Content  string
		Expected tflint.Issues
	}{
		{
			Name: "It includes invalid characters",
			Content: `
resource "aws_cloud9_environment_ec2" "foo" {
	instance_type = "t20.micro"
}`,
			Expected: tflint.Issues{
				{
					Rule:    NewAwsCloud9EnvironmentEc2InvalidInstanceTypeRule(),
					Message: `"t20.micro" does not match valid pattern ^[a-z][1-9][.][a-z0-9]+$`,
				},
			},
		},
		{
			Name: "It is valid",
			Content: `
resource "aws_cloud9_environment_ec2" "foo" {
	instance_type = "t2.micro"
}`,
			Expected: tflint.Issues{},
		},
	}

	rule := NewAwsCloud9EnvironmentEc2InvalidInstanceTypeRule()

	for _, tc := range cases {
		runner := tflint.TestRunner(t, map[string]string{"resource.tf": tc.Content})

		if err := rule.Check(runner); err != nil {
			t.Fatalf("Unexpected error occurred: %s", err)
		}

		tflint.AssertIssuesWithoutRange(t, tc.Expected, runner.Issues)
	}
}
