// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"testing"

	"github.com/terraform-linters/tflint/tflint"
)

func Test_AwsCloudformationStackSetInvalidExecutionRoleNameRule(t *testing.T) {
	cases := []struct {
		Name     string
		Content  string
		Expected tflint.Issues
	}{
		{
			Name: "It includes invalid characters",
			Content: `
resource "aws_cloudformation_stack_set" "foo" {
	execution_role_name = "AWSCloudFormation/StackSet/ExecutionRole"
}`,
			Expected: tflint.Issues{
				{
					Rule:    NewAwsCloudformationStackSetInvalidExecutionRoleNameRule(),
					Message: `"AWSCloudFormation/StackSet/ExecutionRole" does not match valid pattern ^[a-zA-Z_0-9+=,.@-]+$`,
				},
			},
		},
		{
			Name: "It is valid",
			Content: `
resource "aws_cloudformation_stack_set" "foo" {
	execution_role_name = "AWSCloudFormationStackSetExecutionRole"
}`,
			Expected: tflint.Issues{},
		},
	}

	rule := NewAwsCloudformationStackSetInvalidExecutionRoleNameRule()

	for _, tc := range cases {
		runner := tflint.TestRunner(t, map[string]string{"resource.tf": tc.Content})

		if err := rule.Check(runner); err != nil {
			t.Fatalf("Unexpected error occurred: %s", err)
		}

		tflint.AssertIssuesWithoutRange(t, tc.Expected, runner.Issues)
	}
}
