// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"fmt"
	"log"
	"regexp"

	hcl "github.com/hashicorp/hcl/v2"
	"github.com/terraform-linters/tflint/tflint"
)

// AwsCloudhsmV2ClusterInvalidSourceBackupIdentifierRule checks the pattern is valid
type AwsCloudhsmV2ClusterInvalidSourceBackupIdentifierRule struct {
	resourceType  string
	attributeName string
	pattern       *regexp.Regexp
}

// NewAwsCloudhsmV2ClusterInvalidSourceBackupIdentifierRule returns new rule with default attributes
func NewAwsCloudhsmV2ClusterInvalidSourceBackupIdentifierRule() *AwsCloudhsmV2ClusterInvalidSourceBackupIdentifierRule {
	return &AwsCloudhsmV2ClusterInvalidSourceBackupIdentifierRule{
		resourceType:  "aws_cloudhsm_v2_cluster",
		attributeName: "source_backup_identifier",
		pattern:       regexp.MustCompile(`^backup-[2-7a-zA-Z]{11,16}$`),
	}
}

// Name returns the rule name
func (r *AwsCloudhsmV2ClusterInvalidSourceBackupIdentifierRule) Name() string {
	return "aws_cloudhsm_v2_cluster_invalid_source_backup_identifier"
}

// Enabled returns whether the rule is enabled by default
func (r *AwsCloudhsmV2ClusterInvalidSourceBackupIdentifierRule) Enabled() bool {
	return true
}

// Severity returns the rule severity
func (r *AwsCloudhsmV2ClusterInvalidSourceBackupIdentifierRule) Severity() string {
	return tflint.ERROR
}

// Link returns the rule reference link
func (r *AwsCloudhsmV2ClusterInvalidSourceBackupIdentifierRule) Link() string {
	return ""
}

// Check checks the pattern is valid
func (r *AwsCloudhsmV2ClusterInvalidSourceBackupIdentifierRule) Check(runner *tflint.Runner) error {
	log.Printf("[TRACE] Check `%s` rule for `%s` runner", r.Name(), runner.TFConfigPath())

	return runner.WalkResourceAttributes(r.resourceType, r.attributeName, func(attribute *hcl.Attribute) error {
		var val string
		err := runner.EvaluateExpr(attribute.Expr, &val)

		return runner.EnsureNoError(err, func() error {
			if !r.pattern.MatchString(val) {
				runner.EmitIssue(
					r,
					fmt.Sprintf(`"%s" does not match valid pattern %s`, truncateLongMessage(val), `^backup-[2-7a-zA-Z]{11,16}$`),
					attribute.Expr.Range(),
				)
			}
			return nil
		})
	})
}
