// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"fmt"
	"log"
	"regexp"

	hcl "github.com/hashicorp/hcl/v2"
	"github.com/terraform-linters/tflint/tflint"
)

// AwsCloudhsmV2HsmInvalidClusterIDRule checks the pattern is valid
type AwsCloudhsmV2HsmInvalidClusterIDRule struct {
	resourceType  string
	attributeName string
	pattern       *regexp.Regexp
}

// NewAwsCloudhsmV2HsmInvalidClusterIDRule returns new rule with default attributes
func NewAwsCloudhsmV2HsmInvalidClusterIDRule() *AwsCloudhsmV2HsmInvalidClusterIDRule {
	return &AwsCloudhsmV2HsmInvalidClusterIDRule{
		resourceType:  "aws_cloudhsm_v2_hsm",
		attributeName: "cluster_id",
		pattern:       regexp.MustCompile(`^cluster-[2-7a-zA-Z]{11,16}$`),
	}
}

// Name returns the rule name
func (r *AwsCloudhsmV2HsmInvalidClusterIDRule) Name() string {
	return "aws_cloudhsm_v2_hsm_invalid_cluster_id"
}

// Enabled returns whether the rule is enabled by default
func (r *AwsCloudhsmV2HsmInvalidClusterIDRule) Enabled() bool {
	return true
}

// Severity returns the rule severity
func (r *AwsCloudhsmV2HsmInvalidClusterIDRule) Severity() string {
	return tflint.ERROR
}

// Link returns the rule reference link
func (r *AwsCloudhsmV2HsmInvalidClusterIDRule) Link() string {
	return ""
}

// Check checks the pattern is valid
func (r *AwsCloudhsmV2HsmInvalidClusterIDRule) Check(runner *tflint.Runner) error {
	log.Printf("[TRACE] Check `%s` rule for `%s` runner", r.Name(), runner.TFConfigPath())

	return runner.WalkResourceAttributes(r.resourceType, r.attributeName, func(attribute *hcl.Attribute) error {
		var val string
		err := runner.EvaluateExpr(attribute.Expr, &val)

		return runner.EnsureNoError(err, func() error {
			if !r.pattern.MatchString(val) {
				runner.EmitIssue(
					r,
					fmt.Sprintf(`"%s" does not match valid pattern %s`, truncateLongMessage(val), `^cluster-[2-7a-zA-Z]{11,16}$`),
					attribute.Expr.Range(),
				)
			}
			return nil
		})
	})
}
