// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"testing"

	"github.com/terraform-linters/tflint/tflint"
)

func Test_AwsCloudhsmV2HsmInvalidClusterIDRule(t *testing.T) {
	cases := []struct {
		Name     string
		Content  string
		Expected tflint.Issues
	}{
		{
			Name: "It includes invalid characters",
			Content: `
resource "aws_cloudhsm_v2_hsm" "foo" {
	cluster_id = "jxhlf7644ne"
}`,
			Expected: tflint.Issues{
				{
					Rule:    NewAwsCloudhsmV2HsmInvalidClusterIDRule(),
					Message: `"jxhlf7644ne" does not match valid pattern ^cluster-[2-7a-zA-Z]{11,16}$`,
				},
			},
		},
		{
			Name: "It is valid",
			Content: `
resource "aws_cloudhsm_v2_hsm" "foo" {
	cluster_id = "cluster-jxhlf7644ne"
}`,
			Expected: tflint.Issues{},
		},
	}

	rule := NewAwsCloudhsmV2HsmInvalidClusterIDRule()

	for _, tc := range cases {
		runner := tflint.TestRunner(t, map[string]string{"resource.tf": tc.Content})

		if err := rule.Check(runner); err != nil {
			t.Fatalf("Unexpected error occurred: %s", err)
		}

		tflint.AssertIssuesWithoutRange(t, tc.Expected, runner.Issues)
	}
}
