// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"testing"

	"github.com/terraform-linters/tflint/tflint"
)

func Test_AwsCloudwatchEventPermissionInvalidActionRule(t *testing.T) {
	cases := []struct {
		Name     string
		Content  string
		Expected tflint.Issues
	}{
		{
			Name: "It includes invalid characters",
			Content: `
resource "aws_cloudwatch_event_permission" "foo" {
	action = "cloudwatchevents:PutEvents"
}`,
			Expected: tflint.Issues{
				{
					Rule:    NewAwsCloudwatchEventPermissionInvalidActionRule(),
					Message: `"cloudwatchevents:PutEvents" does not match valid pattern ^events:[a-zA-Z]+$`,
				},
			},
		},
		{
			Name: "It is valid",
			Content: `
resource "aws_cloudwatch_event_permission" "foo" {
	action = "events:PutEvents"
}`,
			Expected: tflint.Issues{},
		},
	}

	rule := NewAwsCloudwatchEventPermissionInvalidActionRule()

	for _, tc := range cases {
		runner := tflint.TestRunner(t, map[string]string{"resource.tf": tc.Content})

		if err := rule.Check(runner); err != nil {
			t.Fatalf("Unexpected error occurred: %s", err)
		}

		tflint.AssertIssuesWithoutRange(t, tc.Expected, runner.Issues)
	}
}
