// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"testing"

	"github.com/terraform-linters/tflint/tflint"
)

func Test_AwsCloudwatchEventPermissionInvalidStatementIDRule(t *testing.T) {
	cases := []struct {
		Name     string
		Content  string
		Expected tflint.Issues
	}{
		{
			Name: "It includes invalid characters",
			Content: `
resource "aws_cloudwatch_event_permission" "foo" {
	statement_id = "Organization Access"
}`,
			Expected: tflint.Issues{
				{
					Rule:    NewAwsCloudwatchEventPermissionInvalidStatementIDRule(),
					Message: `"Organization Access" does not match valid pattern ^[a-zA-Z0-9-_]+$`,
				},
			},
		},
		{
			Name: "It is valid",
			Content: `
resource "aws_cloudwatch_event_permission" "foo" {
	statement_id = "OrganizationAccess"
}`,
			Expected: tflint.Issues{},
		},
	}

	rule := NewAwsCloudwatchEventPermissionInvalidStatementIDRule()

	for _, tc := range cases {
		runner := tflint.TestRunner(t, map[string]string{"resource.tf": tc.Content})

		if err := rule.Check(runner); err != nil {
			t.Fatalf("Unexpected error occurred: %s", err)
		}

		tflint.AssertIssuesWithoutRange(t, tc.Expected, runner.Issues)
	}
}
