// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"testing"

	"github.com/terraform-linters/tflint/tflint"
)

func Test_AwsCloudwatchEventRuleInvalidNameRule(t *testing.T) {
	cases := []struct {
		Name     string
		Content  string
		Expected tflint.Issues
	}{
		{
			Name: "It includes invalid characters",
			Content: `
resource "aws_cloudwatch_event_rule" "foo" {
	name = "capture aws sign in"
}`,
			Expected: tflint.Issues{
				{
					Rule:    NewAwsCloudwatchEventRuleInvalidNameRule(),
					Message: `"capture aws sign in" does not match valid pattern ^[\.\-_A-Za-z0-9]+$`,
				},
			},
		},
		{
			Name: "It is valid",
			Content: `
resource "aws_cloudwatch_event_rule" "foo" {
	name = "capture-aws-sign-in"
}`,
			Expected: tflint.Issues{},
		},
	}

	rule := NewAwsCloudwatchEventRuleInvalidNameRule()

	for _, tc := range cases {
		runner := tflint.TestRunner(t, map[string]string{"resource.tf": tc.Content})

		if err := rule.Check(runner); err != nil {
			t.Fatalf("Unexpected error occurred: %s", err)
		}

		tflint.AssertIssuesWithoutRange(t, tc.Expected, runner.Issues)
	}
}
