// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"log"

	hcl "github.com/hashicorp/hcl/v2"
	"github.com/terraform-linters/tflint/tflint"
)

// AwsCloudwatchEventTargetInvalidInputRule checks the pattern is valid
type AwsCloudwatchEventTargetInvalidInputRule struct {
	resourceType  string
	attributeName string
	max           int
}

// NewAwsCloudwatchEventTargetInvalidInputRule returns new rule with default attributes
func NewAwsCloudwatchEventTargetInvalidInputRule() *AwsCloudwatchEventTargetInvalidInputRule {
	return &AwsCloudwatchEventTargetInvalidInputRule{
		resourceType:  "aws_cloudwatch_event_target",
		attributeName: "input",
		max:           8192,
	}
}

// Name returns the rule name
func (r *AwsCloudwatchEventTargetInvalidInputRule) Name() string {
	return "aws_cloudwatch_event_target_invalid_input"
}

// Enabled returns whether the rule is enabled by default
func (r *AwsCloudwatchEventTargetInvalidInputRule) Enabled() bool {
	return true
}

// Severity returns the rule severity
func (r *AwsCloudwatchEventTargetInvalidInputRule) Severity() string {
	return tflint.ERROR
}

// Link returns the rule reference link
func (r *AwsCloudwatchEventTargetInvalidInputRule) Link() string {
	return ""
}

// Check checks the pattern is valid
func (r *AwsCloudwatchEventTargetInvalidInputRule) Check(runner *tflint.Runner) error {
	log.Printf("[TRACE] Check `%s` rule for `%s` runner", r.Name(), runner.TFConfigPath())

	return runner.WalkResourceAttributes(r.resourceType, r.attributeName, func(attribute *hcl.Attribute) error {
		var val string
		err := runner.EvaluateExpr(attribute.Expr, &val)

		return runner.EnsureNoError(err, func() error {
			if len(val) > r.max {
				runner.EmitIssue(
					r,
					"input must be 8192 characters or less",
					attribute.Expr.Range(),
				)
			}
			return nil
		})
	})
}
