// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"log"

	hcl "github.com/hashicorp/hcl/v2"
	"github.com/terraform-linters/tflint/tflint"
)

// AwsCloudwatchLogSubscriptionFilterInvalidFilterPatternRule checks the pattern is valid
type AwsCloudwatchLogSubscriptionFilterInvalidFilterPatternRule struct {
	resourceType  string
	attributeName string
	max           int
}

// NewAwsCloudwatchLogSubscriptionFilterInvalidFilterPatternRule returns new rule with default attributes
func NewAwsCloudwatchLogSubscriptionFilterInvalidFilterPatternRule() *AwsCloudwatchLogSubscriptionFilterInvalidFilterPatternRule {
	return &AwsCloudwatchLogSubscriptionFilterInvalidFilterPatternRule{
		resourceType:  "aws_cloudwatch_log_subscription_filter",
		attributeName: "filter_pattern",
		max:           1024,
	}
}

// Name returns the rule name
func (r *AwsCloudwatchLogSubscriptionFilterInvalidFilterPatternRule) Name() string {
	return "aws_cloudwatch_log_subscription_filter_invalid_filter_pattern"
}

// Enabled returns whether the rule is enabled by default
func (r *AwsCloudwatchLogSubscriptionFilterInvalidFilterPatternRule) Enabled() bool {
	return true
}

// Severity returns the rule severity
func (r *AwsCloudwatchLogSubscriptionFilterInvalidFilterPatternRule) Severity() string {
	return tflint.ERROR
}

// Link returns the rule reference link
func (r *AwsCloudwatchLogSubscriptionFilterInvalidFilterPatternRule) Link() string {
	return ""
}

// Check checks the pattern is valid
func (r *AwsCloudwatchLogSubscriptionFilterInvalidFilterPatternRule) Check(runner *tflint.Runner) error {
	log.Printf("[TRACE] Check `%s` rule for `%s` runner", r.Name(), runner.TFConfigPath())

	return runner.WalkResourceAttributes(r.resourceType, r.attributeName, func(attribute *hcl.Attribute) error {
		var val string
		err := runner.EvaluateExpr(attribute.Expr, &val)

		return runner.EnsureNoError(err, func() error {
			if len(val) > r.max {
				runner.EmitIssue(
					r,
					"filter_pattern must be 1024 characters or less",
					attribute.Expr.Range(),
				)
			}
			return nil
		})
	})
}
