// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"fmt"
	"log"

	hcl "github.com/hashicorp/hcl/v2"
	"github.com/terraform-linters/tflint/tflint"
)

// AwsCloudwatchMetricAlarmInvalidComparisonOperatorRule checks the pattern is valid
type AwsCloudwatchMetricAlarmInvalidComparisonOperatorRule struct {
	resourceType  string
	attributeName string
	enum          []string
}

// NewAwsCloudwatchMetricAlarmInvalidComparisonOperatorRule returns new rule with default attributes
func NewAwsCloudwatchMetricAlarmInvalidComparisonOperatorRule() *AwsCloudwatchMetricAlarmInvalidComparisonOperatorRule {
	return &AwsCloudwatchMetricAlarmInvalidComparisonOperatorRule{
		resourceType:  "aws_cloudwatch_metric_alarm",
		attributeName: "comparison_operator",
		enum: []string{
			"GreaterThanOrEqualToThreshold",
			"GreaterThanThreshold",
			"LessThanThreshold",
			"LessThanOrEqualToThreshold",
			"LessThanLowerOrGreaterThanUpperThreshold",
			"LessThanLowerThreshold",
			"GreaterThanUpperThreshold",
		},
	}
}

// Name returns the rule name
func (r *AwsCloudwatchMetricAlarmInvalidComparisonOperatorRule) Name() string {
	return "aws_cloudwatch_metric_alarm_invalid_comparison_operator"
}

// Enabled returns whether the rule is enabled by default
func (r *AwsCloudwatchMetricAlarmInvalidComparisonOperatorRule) Enabled() bool {
	return true
}

// Severity returns the rule severity
func (r *AwsCloudwatchMetricAlarmInvalidComparisonOperatorRule) Severity() string {
	return tflint.ERROR
}

// Link returns the rule reference link
func (r *AwsCloudwatchMetricAlarmInvalidComparisonOperatorRule) Link() string {
	return ""
}

// Check checks the pattern is valid
func (r *AwsCloudwatchMetricAlarmInvalidComparisonOperatorRule) Check(runner *tflint.Runner) error {
	log.Printf("[TRACE] Check `%s` rule for `%s` runner", r.Name(), runner.TFConfigPath())

	return runner.WalkResourceAttributes(r.resourceType, r.attributeName, func(attribute *hcl.Attribute) error {
		var val string
		err := runner.EvaluateExpr(attribute.Expr, &val)

		return runner.EnsureNoError(err, func() error {
			found := false
			for _, item := range r.enum {
				if item == val {
					found = true
				}
			}
			if !found {
				runner.EmitIssue(
					r,
					fmt.Sprintf(`"%s" is an invalid value as comparison_operator`, truncateLongMessage(val)),
					attribute.Expr.Range(),
				)
			}
			return nil
		})
	})
}
