// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"testing"

	"github.com/terraform-linters/tflint/tflint"
)

func Test_AwsCodecommitRepositoryInvalidRepositoryNameRule(t *testing.T) {
	cases := []struct {
		Name     string
		Content  string
		Expected tflint.Issues
	}{
		{
			Name: "It includes invalid characters",
			Content: `
resource "aws_codecommit_repository" "foo" {
	repository_name = "mytest@repository"
}`,
			Expected: tflint.Issues{
				{
					Rule:    NewAwsCodecommitRepositoryInvalidRepositoryNameRule(),
					Message: `"mytest@repository" does not match valid pattern ^[\w\.-]+$`,
				},
			},
		},
		{
			Name: "It is valid",
			Content: `
resource "aws_codecommit_repository" "foo" {
	repository_name = "MyTestRepository"
}`,
			Expected: tflint.Issues{},
		},
	}

	rule := NewAwsCodecommitRepositoryInvalidRepositoryNameRule()

	for _, tc := range cases {
		runner := tflint.TestRunner(t, map[string]string{"resource.tf": tc.Content})

		if err := rule.Check(runner); err != nil {
			t.Fatalf("Unexpected error occurred: %s", err)
		}

		tflint.AssertIssuesWithoutRange(t, tc.Expected, runner.Issues)
	}
}
