// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"log"

	hcl "github.com/hashicorp/hcl/v2"
	"github.com/terraform-linters/tflint/tflint"
)

// AwsCodedeployDeploymentGroupInvalidDeploymentConfigNameRule checks the pattern is valid
type AwsCodedeployDeploymentGroupInvalidDeploymentConfigNameRule struct {
	resourceType  string
	attributeName string
	max           int
	min           int
}

// NewAwsCodedeployDeploymentGroupInvalidDeploymentConfigNameRule returns new rule with default attributes
func NewAwsCodedeployDeploymentGroupInvalidDeploymentConfigNameRule() *AwsCodedeployDeploymentGroupInvalidDeploymentConfigNameRule {
	return &AwsCodedeployDeploymentGroupInvalidDeploymentConfigNameRule{
		resourceType:  "aws_codedeploy_deployment_group",
		attributeName: "deployment_config_name",
		max:           100,
		min:           1,
	}
}

// Name returns the rule name
func (r *AwsCodedeployDeploymentGroupInvalidDeploymentConfigNameRule) Name() string {
	return "aws_codedeploy_deployment_group_invalid_deployment_config_name"
}

// Enabled returns whether the rule is enabled by default
func (r *AwsCodedeployDeploymentGroupInvalidDeploymentConfigNameRule) Enabled() bool {
	return true
}

// Severity returns the rule severity
func (r *AwsCodedeployDeploymentGroupInvalidDeploymentConfigNameRule) Severity() string {
	return tflint.ERROR
}

// Link returns the rule reference link
func (r *AwsCodedeployDeploymentGroupInvalidDeploymentConfigNameRule) Link() string {
	return ""
}

// Check checks the pattern is valid
func (r *AwsCodedeployDeploymentGroupInvalidDeploymentConfigNameRule) Check(runner *tflint.Runner) error {
	log.Printf("[TRACE] Check `%s` rule for `%s` runner", r.Name(), runner.TFConfigPath())

	return runner.WalkResourceAttributes(r.resourceType, r.attributeName, func(attribute *hcl.Attribute) error {
		var val string
		err := runner.EvaluateExpr(attribute.Expr, &val)

		return runner.EnsureNoError(err, func() error {
			if len(val) > r.max {
				runner.EmitIssue(
					r,
					"deployment_config_name must be 100 characters or less",
					attribute.Expr.Range(),
				)
			}
			if len(val) < r.min {
				runner.EmitIssue(
					r,
					"deployment_config_name must be 1 characters or higher",
					attribute.Expr.Range(),
				)
			}
			return nil
		})
	})
}
