// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"fmt"
	"log"
	"regexp"

	hcl "github.com/hashicorp/hcl/v2"
	"github.com/terraform-linters/tflint/tflint"
)

// AwsCognitoIdentityPoolInvalidDeveloperProviderNameRule checks the pattern is valid
type AwsCognitoIdentityPoolInvalidDeveloperProviderNameRule struct {
	resourceType  string
	attributeName string
	max           int
	min           int
	pattern       *regexp.Regexp
}

// NewAwsCognitoIdentityPoolInvalidDeveloperProviderNameRule returns new rule with default attributes
func NewAwsCognitoIdentityPoolInvalidDeveloperProviderNameRule() *AwsCognitoIdentityPoolInvalidDeveloperProviderNameRule {
	return &AwsCognitoIdentityPoolInvalidDeveloperProviderNameRule{
		resourceType:  "aws_cognito_identity_pool",
		attributeName: "developer_provider_name",
		max:           128,
		min:           1,
		pattern:       regexp.MustCompile(`^[\w._-]+$`),
	}
}

// Name returns the rule name
func (r *AwsCognitoIdentityPoolInvalidDeveloperProviderNameRule) Name() string {
	return "aws_cognito_identity_pool_invalid_developer_provider_name"
}

// Enabled returns whether the rule is enabled by default
func (r *AwsCognitoIdentityPoolInvalidDeveloperProviderNameRule) Enabled() bool {
	return true
}

// Severity returns the rule severity
func (r *AwsCognitoIdentityPoolInvalidDeveloperProviderNameRule) Severity() string {
	return tflint.ERROR
}

// Link returns the rule reference link
func (r *AwsCognitoIdentityPoolInvalidDeveloperProviderNameRule) Link() string {
	return ""
}

// Check checks the pattern is valid
func (r *AwsCognitoIdentityPoolInvalidDeveloperProviderNameRule) Check(runner *tflint.Runner) error {
	log.Printf("[TRACE] Check `%s` rule for `%s` runner", r.Name(), runner.TFConfigPath())

	return runner.WalkResourceAttributes(r.resourceType, r.attributeName, func(attribute *hcl.Attribute) error {
		var val string
		err := runner.EvaluateExpr(attribute.Expr, &val)

		return runner.EnsureNoError(err, func() error {
			if len(val) > r.max {
				runner.EmitIssue(
					r,
					"developer_provider_name must be 128 characters or less",
					attribute.Expr.Range(),
				)
			}
			if len(val) < r.min {
				runner.EmitIssue(
					r,
					"developer_provider_name must be 1 characters or higher",
					attribute.Expr.Range(),
				)
			}
			if !r.pattern.MatchString(val) {
				runner.EmitIssue(
					r,
					fmt.Sprintf(`"%s" does not match valid pattern %s`, truncateLongMessage(val), `^[\w._-]+$`),
					attribute.Expr.Range(),
				)
			}
			return nil
		})
	})
}
