// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"testing"

	"github.com/terraform-linters/tflint/tflint"
)

func Test_AwsCognitoIdentityPoolInvalidIdentityPoolNameRule(t *testing.T) {
	cases := []struct {
		Name     string
		Content  string
		Expected tflint.Issues
	}{
		{
			Name: "It includes invalid characters",
			Content: `
resource "aws_cognito_identity_pool" "foo" {
	identity_pool_name = "identity:pool"
}`,
			Expected: tflint.Issues{
				{
					Rule:    NewAwsCognitoIdentityPoolInvalidIdentityPoolNameRule(),
					Message: `"identity:pool" does not match valid pattern ^[\w\s+=,.@-]+$`,
				},
			},
		},
		{
			Name: "It is valid",
			Content: `
resource "aws_cognito_identity_pool" "foo" {
	identity_pool_name = "identity pool"
}`,
			Expected: tflint.Issues{},
		},
	}

	rule := NewAwsCognitoIdentityPoolInvalidIdentityPoolNameRule()

	for _, tc := range cases {
		runner := tflint.TestRunner(t, map[string]string{"resource.tf": tc.Content})

		if err := rule.Check(runner); err != nil {
			t.Fatalf("Unexpected error occurred: %s", err)
		}

		tflint.AssertIssuesWithoutRange(t, tc.Expected, runner.Issues)
	}
}
