// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"fmt"
	"log"
	"regexp"

	hcl "github.com/hashicorp/hcl/v2"
	"github.com/terraform-linters/tflint/tflint"
)

// AwsCognitoIdentityPoolRolesAttachmentInvalidIdentityPoolIDRule checks the pattern is valid
type AwsCognitoIdentityPoolRolesAttachmentInvalidIdentityPoolIDRule struct {
	resourceType  string
	attributeName string
	max           int
	min           int
	pattern       *regexp.Regexp
}

// NewAwsCognitoIdentityPoolRolesAttachmentInvalidIdentityPoolIDRule returns new rule with default attributes
func NewAwsCognitoIdentityPoolRolesAttachmentInvalidIdentityPoolIDRule() *AwsCognitoIdentityPoolRolesAttachmentInvalidIdentityPoolIDRule {
	return &AwsCognitoIdentityPoolRolesAttachmentInvalidIdentityPoolIDRule{
		resourceType:  "aws_cognito_identity_pool_roles_attachment",
		attributeName: "identity_pool_id",
		max:           55,
		min:           1,
		pattern:       regexp.MustCompile(`^[\w-]+:[0-9a-f-]+$`),
	}
}

// Name returns the rule name
func (r *AwsCognitoIdentityPoolRolesAttachmentInvalidIdentityPoolIDRule) Name() string {
	return "aws_cognito_identity_pool_roles_attachment_invalid_identity_pool_id"
}

// Enabled returns whether the rule is enabled by default
func (r *AwsCognitoIdentityPoolRolesAttachmentInvalidIdentityPoolIDRule) Enabled() bool {
	return true
}

// Severity returns the rule severity
func (r *AwsCognitoIdentityPoolRolesAttachmentInvalidIdentityPoolIDRule) Severity() string {
	return tflint.ERROR
}

// Link returns the rule reference link
func (r *AwsCognitoIdentityPoolRolesAttachmentInvalidIdentityPoolIDRule) Link() string {
	return ""
}

// Check checks the pattern is valid
func (r *AwsCognitoIdentityPoolRolesAttachmentInvalidIdentityPoolIDRule) Check(runner *tflint.Runner) error {
	log.Printf("[TRACE] Check `%s` rule for `%s` runner", r.Name(), runner.TFConfigPath())

	return runner.WalkResourceAttributes(r.resourceType, r.attributeName, func(attribute *hcl.Attribute) error {
		var val string
		err := runner.EvaluateExpr(attribute.Expr, &val)

		return runner.EnsureNoError(err, func() error {
			if len(val) > r.max {
				runner.EmitIssue(
					r,
					"identity_pool_id must be 55 characters or less",
					attribute.Expr.Range(),
				)
			}
			if len(val) < r.min {
				runner.EmitIssue(
					r,
					"identity_pool_id must be 1 characters or higher",
					attribute.Expr.Range(),
				)
			}
			if !r.pattern.MatchString(val) {
				runner.EmitIssue(
					r,
					fmt.Sprintf(`"%s" does not match valid pattern %s`, truncateLongMessage(val), `^[\w-]+:[0-9a-f-]+$`),
					attribute.Expr.Range(),
				)
			}
			return nil
		})
	})
}
