// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"fmt"
	"log"
	"regexp"

	hcl "github.com/hashicorp/hcl/v2"
	"github.com/terraform-linters/tflint/tflint"
)

// AwsCognitoUserPoolClientInvalidDefaultRedirectURIRule checks the pattern is valid
type AwsCognitoUserPoolClientInvalidDefaultRedirectURIRule struct {
	resourceType  string
	attributeName string
	max           int
	min           int
	pattern       *regexp.Regexp
}

// NewAwsCognitoUserPoolClientInvalidDefaultRedirectURIRule returns new rule with default attributes
func NewAwsCognitoUserPoolClientInvalidDefaultRedirectURIRule() *AwsCognitoUserPoolClientInvalidDefaultRedirectURIRule {
	return &AwsCognitoUserPoolClientInvalidDefaultRedirectURIRule{
		resourceType:  "aws_cognito_user_pool_client",
		attributeName: "default_redirect_uri",
		max:           1024,
		min:           1,
		pattern:       regexp.MustCompile(`^[\p{L}\p{M}\p{S}\p{N}\p{P}]+$`),
	}
}

// Name returns the rule name
func (r *AwsCognitoUserPoolClientInvalidDefaultRedirectURIRule) Name() string {
	return "aws_cognito_user_pool_client_invalid_default_redirect_uri"
}

// Enabled returns whether the rule is enabled by default
func (r *AwsCognitoUserPoolClientInvalidDefaultRedirectURIRule) Enabled() bool {
	return true
}

// Severity returns the rule severity
func (r *AwsCognitoUserPoolClientInvalidDefaultRedirectURIRule) Severity() string {
	return tflint.ERROR
}

// Link returns the rule reference link
func (r *AwsCognitoUserPoolClientInvalidDefaultRedirectURIRule) Link() string {
	return ""
}

// Check checks the pattern is valid
func (r *AwsCognitoUserPoolClientInvalidDefaultRedirectURIRule) Check(runner *tflint.Runner) error {
	log.Printf("[TRACE] Check `%s` rule for `%s` runner", r.Name(), runner.TFConfigPath())

	return runner.WalkResourceAttributes(r.resourceType, r.attributeName, func(attribute *hcl.Attribute) error {
		var val string
		err := runner.EvaluateExpr(attribute.Expr, &val)

		return runner.EnsureNoError(err, func() error {
			if len(val) > r.max {
				runner.EmitIssue(
					r,
					"default_redirect_uri must be 1024 characters or less",
					attribute.Expr.Range(),
				)
			}
			if len(val) < r.min {
				runner.EmitIssue(
					r,
					"default_redirect_uri must be 1 characters or higher",
					attribute.Expr.Range(),
				)
			}
			if !r.pattern.MatchString(val) {
				runner.EmitIssue(
					r,
					fmt.Sprintf(`"%s" does not match valid pattern %s`, truncateLongMessage(val), `^[\p{L}\p{M}\p{S}\p{N}\p{P}]+$`),
					attribute.Expr.Range(),
				)
			}
			return nil
		})
	})
}
