// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"testing"

	"github.com/terraform-linters/tflint/tflint"
)

func Test_AwsCognitoUserPoolClientInvalidDefaultRedirectURIRule(t *testing.T) {
	cases := []struct {
		Name     string
		Content  string
		Expected tflint.Issues
	}{
		{
			Name: "It includes invalid characters",
			Content: `
resource "aws_cognito_user_pool_client" "foo" {
	default_redirect_uri = "https://example com"
}`,
			Expected: tflint.Issues{
				{
					Rule:    NewAwsCognitoUserPoolClientInvalidDefaultRedirectURIRule(),
					Message: `"https://example com" does not match valid pattern ^[\p{L}\p{M}\p{S}\p{N}\p{P}]+$`,
				},
			},
		},
		{
			Name: "It is valid",
			Content: `
resource "aws_cognito_user_pool_client" "foo" {
	default_redirect_uri = "https://example.com/callback"
}`,
			Expected: tflint.Issues{},
		},
	}

	rule := NewAwsCognitoUserPoolClientInvalidDefaultRedirectURIRule()

	for _, tc := range cases {
		runner := tflint.TestRunner(t, map[string]string{"resource.tf": tc.Content})

		if err := rule.Check(runner); err != nil {
			t.Fatalf("Unexpected error occurred: %s", err)
		}

		tflint.AssertIssuesWithoutRange(t, tc.Expected, runner.Issues)
	}
}
