// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"testing"

	"github.com/terraform-linters/tflint/tflint"
)

func Test_AwsCognitoUserPoolDomainInvalidDomainRule(t *testing.T) {
	cases := []struct {
		Name     string
		Content  string
		Expected tflint.Issues
	}{
		{
			Name: "It includes invalid characters",
			Content: `
resource "aws_cognito_user_pool_domain" "foo" {
	domain = "auth example"
}`,
			Expected: tflint.Issues{
				{
					Rule:    NewAwsCognitoUserPoolDomainInvalidDomainRule(),
					Message: `"auth example" does not match valid pattern ^[a-z0-9](?:[a-z0-9\-]{0,61}[a-z0-9])?$`,
				},
			},
		},
		{
			Name: "It is valid",
			Content: `
resource "aws_cognito_user_pool_domain" "foo" {
	domain = "auth"
}`,
			Expected: tflint.Issues{},
		},
	}

	rule := NewAwsCognitoUserPoolDomainInvalidDomainRule()

	for _, tc := range cases {
		runner := tflint.TestRunner(t, map[string]string{"resource.tf": tc.Content})

		if err := rule.Check(runner); err != nil {
			t.Fatalf("Unexpected error occurred: %s", err)
		}

		tflint.AssertIssuesWithoutRange(t, tc.Expected, runner.Issues)
	}
}
