// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"fmt"
	"log"
	"regexp"

	hcl "github.com/hashicorp/hcl/v2"
	"github.com/terraform-linters/tflint/tflint"
)

// AwsCognitoUserPoolDomainInvalidUserPoolIDRule checks the pattern is valid
type AwsCognitoUserPoolDomainInvalidUserPoolIDRule struct {
	resourceType  string
	attributeName string
	max           int
	min           int
	pattern       *regexp.Regexp
}

// NewAwsCognitoUserPoolDomainInvalidUserPoolIDRule returns new rule with default attributes
func NewAwsCognitoUserPoolDomainInvalidUserPoolIDRule() *AwsCognitoUserPoolDomainInvalidUserPoolIDRule {
	return &AwsCognitoUserPoolDomainInvalidUserPoolIDRule{
		resourceType:  "aws_cognito_user_pool_domain",
		attributeName: "user_pool_id",
		max:           55,
		min:           1,
		pattern:       regexp.MustCompile(`^[\w-]+_[0-9a-zA-Z]+$`),
	}
}

// Name returns the rule name
func (r *AwsCognitoUserPoolDomainInvalidUserPoolIDRule) Name() string {
	return "aws_cognito_user_pool_domain_invalid_user_pool_id"
}

// Enabled returns whether the rule is enabled by default
func (r *AwsCognitoUserPoolDomainInvalidUserPoolIDRule) Enabled() bool {
	return true
}

// Severity returns the rule severity
func (r *AwsCognitoUserPoolDomainInvalidUserPoolIDRule) Severity() string {
	return tflint.ERROR
}

// Link returns the rule reference link
func (r *AwsCognitoUserPoolDomainInvalidUserPoolIDRule) Link() string {
	return ""
}

// Check checks the pattern is valid
func (r *AwsCognitoUserPoolDomainInvalidUserPoolIDRule) Check(runner *tflint.Runner) error {
	log.Printf("[TRACE] Check `%s` rule for `%s` runner", r.Name(), runner.TFConfigPath())

	return runner.WalkResourceAttributes(r.resourceType, r.attributeName, func(attribute *hcl.Attribute) error {
		var val string
		err := runner.EvaluateExpr(attribute.Expr, &val)

		return runner.EnsureNoError(err, func() error {
			if len(val) > r.max {
				runner.EmitIssue(
					r,
					"user_pool_id must be 55 characters or less",
					attribute.Expr.Range(),
				)
			}
			if len(val) < r.min {
				runner.EmitIssue(
					r,
					"user_pool_id must be 1 characters or higher",
					attribute.Expr.Range(),
				)
			}
			if !r.pattern.MatchString(val) {
				runner.EmitIssue(
					r,
					fmt.Sprintf(`"%s" does not match valid pattern %s`, truncateLongMessage(val), `^[\w-]+_[0-9a-zA-Z]+$`),
					attribute.Expr.Range(),
				)
			}
			return nil
		})
	})
}
