// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"testing"

	"github.com/terraform-linters/tflint/tflint"
)

func Test_AwsConfigAggregateAuthorizationInvalidAccountIDRule(t *testing.T) {
	cases := []struct {
		Name     string
		Content  string
		Expected tflint.Issues
	}{
		{
			Name: "It includes invalid characters",
			Content: `
resource "aws_config_aggregate_authorization" "foo" {
	account_id = "01234567891"
}`,
			Expected: tflint.Issues{
				{
					Rule:    NewAwsConfigAggregateAuthorizationInvalidAccountIDRule(),
					Message: `"01234567891" does not match valid pattern ^\d{12}$`,
				},
			},
		},
		{
			Name: "It is valid",
			Content: `
resource "aws_config_aggregate_authorization" "foo" {
	account_id = "012345678910"
}`,
			Expected: tflint.Issues{},
		},
	}

	rule := NewAwsConfigAggregateAuthorizationInvalidAccountIDRule()

	for _, tc := range cases {
		runner := tflint.TestRunner(t, map[string]string{"resource.tf": tc.Content})

		if err := rule.Check(runner); err != nil {
			t.Fatalf("Unexpected error occurred: %s", err)
		}

		tflint.AssertIssuesWithoutRange(t, tc.Expected, runner.Issues)
	}
}
