// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"testing"

	"github.com/terraform-linters/tflint/tflint"
)

func Test_AwsConfigConfigRuleInvalidMaximumExecutionFrequencyRule(t *testing.T) {
	cases := []struct {
		Name     string
		Content  string
		Expected tflint.Issues
	}{
		{
			Name: "It includes invalid characters",
			Content: `
resource "aws_config_config_rule" "foo" {
	maximum_execution_frequency = "Hour"
}`,
			Expected: tflint.Issues{
				{
					Rule:    NewAwsConfigConfigRuleInvalidMaximumExecutionFrequencyRule(),
					Message: `"Hour" is an invalid value as maximum_execution_frequency`,
				},
			},
		},
		{
			Name: "It is valid",
			Content: `
resource "aws_config_config_rule" "foo" {
	maximum_execution_frequency = "One_Hour"
}`,
			Expected: tflint.Issues{},
		},
	}

	rule := NewAwsConfigConfigRuleInvalidMaximumExecutionFrequencyRule()

	for _, tc := range cases {
		runner := tflint.TestRunner(t, map[string]string{"resource.tf": tc.Content})

		if err := rule.Check(runner); err != nil {
			t.Fatalf("Unexpected error occurred: %s", err)
		}

		tflint.AssertIssuesWithoutRange(t, tc.Expected, runner.Issues)
	}
}
