// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"testing"

	"github.com/terraform-linters/tflint/tflint"
)

func Test_AwsCurReportDefinitionInvalidCompressionRule(t *testing.T) {
	cases := []struct {
		Name     string
		Content  string
		Expected tflint.Issues
	}{
		{
			Name: "It includes invalid characters",
			Content: `
resource "aws_cur_report_definition" "foo" {
	compression = "TAR"
}`,
			Expected: tflint.Issues{
				{
					Rule:    NewAwsCurReportDefinitionInvalidCompressionRule(),
					Message: `"TAR" is an invalid value as compression`,
				},
			},
		},
		{
			Name: "It is valid",
			Content: `
resource "aws_cur_report_definition" "foo" {
	compression = "ZIP"
}`,
			Expected: tflint.Issues{},
		},
	}

	rule := NewAwsCurReportDefinitionInvalidCompressionRule()

	for _, tc := range cases {
		runner := tflint.TestRunner(t, map[string]string{"resource.tf": tc.Content})

		if err := rule.Check(runner); err != nil {
			t.Fatalf("Unexpected error occurred: %s", err)
		}

		tflint.AssertIssuesWithoutRange(t, tc.Expected, runner.Issues)
	}
}
