// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"fmt"
	"log"
	"regexp"

	hcl "github.com/hashicorp/hcl/v2"
	"github.com/terraform-linters/tflint/tflint"
)

// AwsCurReportDefinitionInvalidReportNameRule checks the pattern is valid
type AwsCurReportDefinitionInvalidReportNameRule struct {
	resourceType  string
	attributeName string
	max           int
	pattern       *regexp.Regexp
}

// NewAwsCurReportDefinitionInvalidReportNameRule returns new rule with default attributes
func NewAwsCurReportDefinitionInvalidReportNameRule() *AwsCurReportDefinitionInvalidReportNameRule {
	return &AwsCurReportDefinitionInvalidReportNameRule{
		resourceType:  "aws_cur_report_definition",
		attributeName: "report_name",
		max:           256,
		pattern:       regexp.MustCompile(`^[0-9A-Za-z!\-_.*\'()]+$`),
	}
}

// Name returns the rule name
func (r *AwsCurReportDefinitionInvalidReportNameRule) Name() string {
	return "aws_cur_report_definition_invalid_report_name"
}

// Enabled returns whether the rule is enabled by default
func (r *AwsCurReportDefinitionInvalidReportNameRule) Enabled() bool {
	return true
}

// Severity returns the rule severity
func (r *AwsCurReportDefinitionInvalidReportNameRule) Severity() string {
	return tflint.ERROR
}

// Link returns the rule reference link
func (r *AwsCurReportDefinitionInvalidReportNameRule) Link() string {
	return ""
}

// Check checks the pattern is valid
func (r *AwsCurReportDefinitionInvalidReportNameRule) Check(runner *tflint.Runner) error {
	log.Printf("[TRACE] Check `%s` rule for `%s` runner", r.Name(), runner.TFConfigPath())

	return runner.WalkResourceAttributes(r.resourceType, r.attributeName, func(attribute *hcl.Attribute) error {
		var val string
		err := runner.EvaluateExpr(attribute.Expr, &val)

		return runner.EnsureNoError(err, func() error {
			if len(val) > r.max {
				runner.EmitIssue(
					r,
					"report_name must be 256 characters or less",
					attribute.Expr.Range(),
				)
			}
			if !r.pattern.MatchString(val) {
				runner.EmitIssue(
					r,
					fmt.Sprintf(`"%s" does not match valid pattern %s`, truncateLongMessage(val), `^[0-9A-Za-z!\-_.*\'()]+$`),
					attribute.Expr.Range(),
				)
			}
			return nil
		})
	})
}
