// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"testing"

	"github.com/terraform-linters/tflint/tflint"
)

func Test_AwsDatasyncAgentInvalidActivationKeyRule(t *testing.T) {
	cases := []struct {
		Name     string
		Content  string
		Expected tflint.Issues
	}{
		{
			Name: "It includes invalid characters",
			Content: `
resource "aws_datasync_agent" "foo" {
	activation_key = "F0EFT7FPPRGG7MC3I9R327DOH"
}`,
			Expected: tflint.Issues{
				{
					Rule:    NewAwsDatasyncAgentInvalidActivationKeyRule(),
					Message: `"F0EFT7FPPRGG7MC3I9R327DOH" does not match valid pattern ^[A-Z0-9]{5}(-[A-Z0-9]{5}){4}$`,
				},
			},
		},
		{
			Name: "It is valid",
			Content: `
resource "aws_datasync_agent" "foo" {
	activation_key = "F0EFT-7FPPR-GG7MC-3I9R3-27DOH"
}`,
			Expected: tflint.Issues{},
		},
	}

	rule := NewAwsDatasyncAgentInvalidActivationKeyRule()

	for _, tc := range cases {
		runner := tflint.TestRunner(t, map[string]string{"resource.tf": tc.Content})

		if err := rule.Check(runner); err != nil {
			t.Fatalf("Unexpected error occurred: %s", err)
		}

		tflint.AssertIssuesWithoutRange(t, tc.Expected, runner.Issues)
	}
}
