// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"fmt"
	"log"
	"regexp"

	hcl "github.com/hashicorp/hcl/v2"
	"github.com/terraform-linters/tflint/tflint"
)

// AwsDatasyncTaskInvalidCloudwatchLogGroupArnRule checks the pattern is valid
type AwsDatasyncTaskInvalidCloudwatchLogGroupArnRule struct {
	resourceType  string
	attributeName string
	max           int
	pattern       *regexp.Regexp
}

// NewAwsDatasyncTaskInvalidCloudwatchLogGroupArnRule returns new rule with default attributes
func NewAwsDatasyncTaskInvalidCloudwatchLogGroupArnRule() *AwsDatasyncTaskInvalidCloudwatchLogGroupArnRule {
	return &AwsDatasyncTaskInvalidCloudwatchLogGroupArnRule{
		resourceType:  "aws_datasync_task",
		attributeName: "cloudwatch_log_group_arn",
		max:           562,
		pattern:       regexp.MustCompile(`^arn:(aws|aws-cn|aws-us-gov|aws-iso|aws-iso-b):logs:[a-z\-0-9]*:[0-9]{12}:log-group:([^:\*]*)(:\*)?$`),
	}
}

// Name returns the rule name
func (r *AwsDatasyncTaskInvalidCloudwatchLogGroupArnRule) Name() string {
	return "aws_datasync_task_invalid_cloudwatch_log_group_arn"
}

// Enabled returns whether the rule is enabled by default
func (r *AwsDatasyncTaskInvalidCloudwatchLogGroupArnRule) Enabled() bool {
	return true
}

// Severity returns the rule severity
func (r *AwsDatasyncTaskInvalidCloudwatchLogGroupArnRule) Severity() string {
	return tflint.ERROR
}

// Link returns the rule reference link
func (r *AwsDatasyncTaskInvalidCloudwatchLogGroupArnRule) Link() string {
	return ""
}

// Check checks the pattern is valid
func (r *AwsDatasyncTaskInvalidCloudwatchLogGroupArnRule) Check(runner *tflint.Runner) error {
	log.Printf("[TRACE] Check `%s` rule for `%s` runner", r.Name(), runner.TFConfigPath())

	return runner.WalkResourceAttributes(r.resourceType, r.attributeName, func(attribute *hcl.Attribute) error {
		var val string
		err := runner.EvaluateExpr(attribute.Expr, &val)

		return runner.EnsureNoError(err, func() error {
			if len(val) > r.max {
				runner.EmitIssue(
					r,
					"cloudwatch_log_group_arn must be 562 characters or less",
					attribute.Expr.Range(),
				)
			}
			if !r.pattern.MatchString(val) {
				runner.EmitIssue(
					r,
					fmt.Sprintf(`"%s" does not match valid pattern %s`, truncateLongMessage(val), `^arn:(aws|aws-cn|aws-us-gov|aws-iso|aws-iso-b):logs:[a-z\-0-9]*:[0-9]{12}:log-group:([^:\*]*)(:\*)?$`),
					attribute.Expr.Range(),
				)
			}
			return nil
		})
	})
}
