// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"fmt"
	"log"
	"regexp"

	hcl "github.com/hashicorp/hcl/v2"
	"github.com/terraform-linters/tflint/tflint"
)

// AwsDatasyncTaskInvalidDestinationLocationArnRule checks the pattern is valid
type AwsDatasyncTaskInvalidDestinationLocationArnRule struct {
	resourceType  string
	attributeName string
	max           int
	pattern       *regexp.Regexp
}

// NewAwsDatasyncTaskInvalidDestinationLocationArnRule returns new rule with default attributes
func NewAwsDatasyncTaskInvalidDestinationLocationArnRule() *AwsDatasyncTaskInvalidDestinationLocationArnRule {
	return &AwsDatasyncTaskInvalidDestinationLocationArnRule{
		resourceType:  "aws_datasync_task",
		attributeName: "destination_location_arn",
		max:           128,
		pattern:       regexp.MustCompile(`^arn:(aws|aws-cn|aws-us-gov|aws-iso|aws-iso-b):datasync:[a-z\-0-9]+:[0-9]{12}:location/loc-[0-9a-z]{17}$`),
	}
}

// Name returns the rule name
func (r *AwsDatasyncTaskInvalidDestinationLocationArnRule) Name() string {
	return "aws_datasync_task_invalid_destination_location_arn"
}

// Enabled returns whether the rule is enabled by default
func (r *AwsDatasyncTaskInvalidDestinationLocationArnRule) Enabled() bool {
	return true
}

// Severity returns the rule severity
func (r *AwsDatasyncTaskInvalidDestinationLocationArnRule) Severity() string {
	return tflint.ERROR
}

// Link returns the rule reference link
func (r *AwsDatasyncTaskInvalidDestinationLocationArnRule) Link() string {
	return ""
}

// Check checks the pattern is valid
func (r *AwsDatasyncTaskInvalidDestinationLocationArnRule) Check(runner *tflint.Runner) error {
	log.Printf("[TRACE] Check `%s` rule for `%s` runner", r.Name(), runner.TFConfigPath())

	return runner.WalkResourceAttributes(r.resourceType, r.attributeName, func(attribute *hcl.Attribute) error {
		var val string
		err := runner.EvaluateExpr(attribute.Expr, &val)

		return runner.EnsureNoError(err, func() error {
			if len(val) > r.max {
				runner.EmitIssue(
					r,
					"destination_location_arn must be 128 characters or less",
					attribute.Expr.Range(),
				)
			}
			if !r.pattern.MatchString(val) {
				runner.EmitIssue(
					r,
					fmt.Sprintf(`"%s" does not match valid pattern %s`, truncateLongMessage(val), `^arn:(aws|aws-cn|aws-us-gov|aws-iso|aws-iso-b):datasync:[a-z\-0-9]+:[0-9]{12}:location/loc-[0-9a-z]{17}$`),
					attribute.Expr.Range(),
				)
			}
			return nil
		})
	})
}
