// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"log"

	hcl "github.com/hashicorp/hcl/v2"
	"github.com/terraform-linters/tflint/tflint"
)

// AwsDirectoryServiceDirectoryInvalidPasswordRule checks the pattern is valid
type AwsDirectoryServiceDirectoryInvalidPasswordRule struct {
	resourceType  string
	attributeName string
	max           int
	min           int
}

// NewAwsDirectoryServiceDirectoryInvalidPasswordRule returns new rule with default attributes
func NewAwsDirectoryServiceDirectoryInvalidPasswordRule() *AwsDirectoryServiceDirectoryInvalidPasswordRule {
	return &AwsDirectoryServiceDirectoryInvalidPasswordRule{
		resourceType:  "aws_directory_service_directory",
		attributeName: "password",
		max:           128,
		min:           1,
	}
}

// Name returns the rule name
func (r *AwsDirectoryServiceDirectoryInvalidPasswordRule) Name() string {
	return "aws_directory_service_directory_invalid_password"
}

// Enabled returns whether the rule is enabled by default
func (r *AwsDirectoryServiceDirectoryInvalidPasswordRule) Enabled() bool {
	return true
}

// Severity returns the rule severity
func (r *AwsDirectoryServiceDirectoryInvalidPasswordRule) Severity() string {
	return tflint.ERROR
}

// Link returns the rule reference link
func (r *AwsDirectoryServiceDirectoryInvalidPasswordRule) Link() string {
	return ""
}

// Check checks the pattern is valid
func (r *AwsDirectoryServiceDirectoryInvalidPasswordRule) Check(runner *tflint.Runner) error {
	log.Printf("[TRACE] Check `%s` rule for `%s` runner", r.Name(), runner.TFConfigPath())

	return runner.WalkResourceAttributes(r.resourceType, r.attributeName, func(attribute *hcl.Attribute) error {
		var val string
		err := runner.EvaluateExpr(attribute.Expr, &val)

		return runner.EnsureNoError(err, func() error {
			if len(val) > r.max {
				runner.EmitIssue(
					r,
					"password must be 128 characters or less",
					attribute.Expr.Range(),
				)
			}
			if len(val) < r.min {
				runner.EmitIssue(
					r,
					"password must be 1 characters or higher",
					attribute.Expr.Range(),
				)
			}
			return nil
		})
	})
}
