// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"fmt"
	"log"
	"regexp"

	hcl "github.com/hashicorp/hcl/v2"
	"github.com/terraform-linters/tflint/tflint"
)

// AwsDirectoryServiceDirectoryInvalidShortNameRule checks the pattern is valid
type AwsDirectoryServiceDirectoryInvalidShortNameRule struct {
	resourceType  string
	attributeName string
	pattern       *regexp.Regexp
}

// NewAwsDirectoryServiceDirectoryInvalidShortNameRule returns new rule with default attributes
func NewAwsDirectoryServiceDirectoryInvalidShortNameRule() *AwsDirectoryServiceDirectoryInvalidShortNameRule {
	return &AwsDirectoryServiceDirectoryInvalidShortNameRule{
		resourceType:  "aws_directory_service_directory",
		attributeName: "short_name",
		pattern:       regexp.MustCompile(`^[^\\/:*?"<>|.]+[^\\/:*?"<>|]*$`),
	}
}

// Name returns the rule name
func (r *AwsDirectoryServiceDirectoryInvalidShortNameRule) Name() string {
	return "aws_directory_service_directory_invalid_short_name"
}

// Enabled returns whether the rule is enabled by default
func (r *AwsDirectoryServiceDirectoryInvalidShortNameRule) Enabled() bool {
	return true
}

// Severity returns the rule severity
func (r *AwsDirectoryServiceDirectoryInvalidShortNameRule) Severity() string {
	return tflint.ERROR
}

// Link returns the rule reference link
func (r *AwsDirectoryServiceDirectoryInvalidShortNameRule) Link() string {
	return ""
}

// Check checks the pattern is valid
func (r *AwsDirectoryServiceDirectoryInvalidShortNameRule) Check(runner *tflint.Runner) error {
	log.Printf("[TRACE] Check `%s` rule for `%s` runner", r.Name(), runner.TFConfigPath())

	return runner.WalkResourceAttributes(r.resourceType, r.attributeName, func(attribute *hcl.Attribute) error {
		var val string
		err := runner.EvaluateExpr(attribute.Expr, &val)

		return runner.EnsureNoError(err, func() error {
			if !r.pattern.MatchString(val) {
				runner.EmitIssue(
					r,
					fmt.Sprintf(`"%s" does not match valid pattern %s`, truncateLongMessage(val), `^[^\\/:*?"<>|.]+[^\\/:*?"<>|]*$`),
					attribute.Expr.Range(),
				)
			}
			return nil
		})
	})
}
