// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"testing"

	"github.com/terraform-linters/tflint/tflint"
)

func Test_AwsDirectoryServiceDirectoryInvalidShortNameRule(t *testing.T) {
	cases := []struct {
		Name     string
		Content  string
		Expected tflint.Issues
	}{
		{
			Name: "It includes invalid characters",
			Content: `
resource "aws_directory_service_directory" "foo" {
	short_name = "CORP:EXAMPLE"
}`,
			Expected: tflint.Issues{
				{
					Rule:    NewAwsDirectoryServiceDirectoryInvalidShortNameRule(),
					Message: `"CORP:EXAMPLE" does not match valid pattern ^[^\\/:*?"<>|.]+[^\\/:*?"<>|]*$`,
				},
			},
		},
		{
			Name: "It is valid",
			Content: `
resource "aws_directory_service_directory" "foo" {
	short_name = "CORP"
}`,
			Expected: tflint.Issues{},
		},
	}

	rule := NewAwsDirectoryServiceDirectoryInvalidShortNameRule()

	for _, tc := range cases {
		runner := tflint.TestRunner(t, map[string]string{"resource.tf": tc.Content})

		if err := rule.Check(runner); err != nil {
			t.Fatalf("Unexpected error occurred: %s", err)
		}

		tflint.AssertIssuesWithoutRange(t, tc.Expected, runner.Issues)
	}
}
