// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"fmt"
	"log"

	hcl "github.com/hashicorp/hcl/v2"
	"github.com/terraform-linters/tflint/tflint"
)

// AwsDmsReplicationTaskInvalidMigrationTypeRule checks the pattern is valid
type AwsDmsReplicationTaskInvalidMigrationTypeRule struct {
	resourceType  string
	attributeName string
	enum          []string
}

// NewAwsDmsReplicationTaskInvalidMigrationTypeRule returns new rule with default attributes
func NewAwsDmsReplicationTaskInvalidMigrationTypeRule() *AwsDmsReplicationTaskInvalidMigrationTypeRule {
	return &AwsDmsReplicationTaskInvalidMigrationTypeRule{
		resourceType:  "aws_dms_replication_task",
		attributeName: "migration_type",
		enum: []string{
			"full-load",
			"cdc",
			"full-load-and-cdc",
		},
	}
}

// Name returns the rule name
func (r *AwsDmsReplicationTaskInvalidMigrationTypeRule) Name() string {
	return "aws_dms_replication_task_invalid_migration_type"
}

// Enabled returns whether the rule is enabled by default
func (r *AwsDmsReplicationTaskInvalidMigrationTypeRule) Enabled() bool {
	return true
}

// Severity returns the rule severity
func (r *AwsDmsReplicationTaskInvalidMigrationTypeRule) Severity() string {
	return tflint.ERROR
}

// Link returns the rule reference link
func (r *AwsDmsReplicationTaskInvalidMigrationTypeRule) Link() string {
	return ""
}

// Check checks the pattern is valid
func (r *AwsDmsReplicationTaskInvalidMigrationTypeRule) Check(runner *tflint.Runner) error {
	log.Printf("[TRACE] Check `%s` rule for `%s` runner", r.Name(), runner.TFConfigPath())

	return runner.WalkResourceAttributes(r.resourceType, r.attributeName, func(attribute *hcl.Attribute) error {
		var val string
		err := runner.EvaluateExpr(attribute.Expr, &val)

		return runner.EnsureNoError(err, func() error {
			found := false
			for _, item := range r.enum {
				if item == val {
					found = true
				}
			}
			if !found {
				runner.EmitIssue(
					r,
					fmt.Sprintf(`"%s" is an invalid value as migration_type`, truncateLongMessage(val)),
					attribute.Expr.Range(),
				)
			}
			return nil
		})
	})
}
