// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"testing"

	"github.com/terraform-linters/tflint/tflint"
)

func Test_AwsEc2CapacityReservationInvalidEndDateTypeRule(t *testing.T) {
	cases := []struct {
		Name     string
		Content  string
		Expected tflint.Issues
	}{
		{
			Name: "It includes invalid characters",
			Content: `
resource "aws_ec2_capacity_reservation" "foo" {
	end_date_type = "unlimit"
}`,
			Expected: tflint.Issues{
				{
					Rule:    NewAwsEc2CapacityReservationInvalidEndDateTypeRule(),
					Message: `"unlimit" is an invalid value as end_date_type`,
				},
			},
		},
		{
			Name: "It is valid",
			Content: `
resource "aws_ec2_capacity_reservation" "foo" {
	end_date_type = "unlimited"
}`,
			Expected: tflint.Issues{},
		},
	}

	rule := NewAwsEc2CapacityReservationInvalidEndDateTypeRule()

	for _, tc := range cases {
		runner := tflint.TestRunner(t, map[string]string{"resource.tf": tc.Content})

		if err := rule.Check(runner); err != nil {
			t.Fatalf("Unexpected error occurred: %s", err)
		}

		tflint.AssertIssuesWithoutRange(t, tc.Expected, runner.Issues)
	}
}
