// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"testing"

	"github.com/terraform-linters/tflint/tflint"
)

func Test_AwsEc2ClientVpnEndpointInvalidTransportProtocolRule(t *testing.T) {
	cases := []struct {
		Name     string
		Content  string
		Expected tflint.Issues
	}{
		{
			Name: "It includes invalid characters",
			Content: `
resource "aws_ec2_client_vpn_endpoint" "foo" {
	transport_protocol = "http"
}`,
			Expected: tflint.Issues{
				{
					Rule:    NewAwsEc2ClientVpnEndpointInvalidTransportProtocolRule(),
					Message: `"http" is an invalid value as transport_protocol`,
				},
			},
		},
		{
			Name: "It is valid",
			Content: `
resource "aws_ec2_client_vpn_endpoint" "foo" {
	transport_protocol = "udp"
}`,
			Expected: tflint.Issues{},
		},
	}

	rule := NewAwsEc2ClientVpnEndpointInvalidTransportProtocolRule()

	for _, tc := range cases {
		runner := tflint.TestRunner(t, map[string]string{"resource.tf": tc.Content})

		if err := rule.Check(runner); err != nil {
			t.Fatalf("Unexpected error occurred: %s", err)
		}

		tflint.AssertIssuesWithoutRange(t, tc.Expected, runner.Issues)
	}
}
