// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"testing"

	"github.com/terraform-linters/tflint/tflint"
)

func Test_AwsEc2TransitGatewayInvalidDefaultRouteTableAssociationRule(t *testing.T) {
	cases := []struct {
		Name     string
		Content  string
		Expected tflint.Issues
	}{
		{
			Name: "It includes invalid characters",
			Content: `
resource "aws_ec2_transit_gateway" "foo" {
	default_route_table_association = "false"
}`,
			Expected: tflint.Issues{
				{
					Rule:    NewAwsEc2TransitGatewayInvalidDefaultRouteTableAssociationRule(),
					Message: `"false" is an invalid value as default_route_table_association`,
				},
			},
		},
		{
			Name: "It is valid",
			Content: `
resource "aws_ec2_transit_gateway" "foo" {
	default_route_table_association = "disable"
}`,
			Expected: tflint.Issues{},
		},
	}

	rule := NewAwsEc2TransitGatewayInvalidDefaultRouteTableAssociationRule()

	for _, tc := range cases {
		runner := tflint.TestRunner(t, map[string]string{"resource.tf": tc.Content})

		if err := rule.Check(runner); err != nil {
			t.Fatalf("Unexpected error occurred: %s", err)
		}

		tflint.AssertIssuesWithoutRange(t, tc.Expected, runner.Issues)
	}
}
