// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"fmt"
	"log"

	hcl "github.com/hashicorp/hcl/v2"
	"github.com/terraform-linters/tflint/tflint"
)

// AwsEc2TransitGatewayInvalidDefaultRouteTablePropagationRule checks the pattern is valid
type AwsEc2TransitGatewayInvalidDefaultRouteTablePropagationRule struct {
	resourceType  string
	attributeName string
	enum          []string
}

// NewAwsEc2TransitGatewayInvalidDefaultRouteTablePropagationRule returns new rule with default attributes
func NewAwsEc2TransitGatewayInvalidDefaultRouteTablePropagationRule() *AwsEc2TransitGatewayInvalidDefaultRouteTablePropagationRule {
	return &AwsEc2TransitGatewayInvalidDefaultRouteTablePropagationRule{
		resourceType:  "aws_ec2_transit_gateway",
		attributeName: "default_route_table_propagation",
		enum: []string{
			"enable",
			"disable",
		},
	}
}

// Name returns the rule name
func (r *AwsEc2TransitGatewayInvalidDefaultRouteTablePropagationRule) Name() string {
	return "aws_ec2_transit_gateway_invalid_default_route_table_propagation"
}

// Enabled returns whether the rule is enabled by default
func (r *AwsEc2TransitGatewayInvalidDefaultRouteTablePropagationRule) Enabled() bool {
	return true
}

// Severity returns the rule severity
func (r *AwsEc2TransitGatewayInvalidDefaultRouteTablePropagationRule) Severity() string {
	return tflint.ERROR
}

// Link returns the rule reference link
func (r *AwsEc2TransitGatewayInvalidDefaultRouteTablePropagationRule) Link() string {
	return ""
}

// Check checks the pattern is valid
func (r *AwsEc2TransitGatewayInvalidDefaultRouteTablePropagationRule) Check(runner *tflint.Runner) error {
	log.Printf("[TRACE] Check `%s` rule for `%s` runner", r.Name(), runner.TFConfigPath())

	return runner.WalkResourceAttributes(r.resourceType, r.attributeName, func(attribute *hcl.Attribute) error {
		var val string
		err := runner.EvaluateExpr(attribute.Expr, &val)

		return runner.EnsureNoError(err, func() error {
			found := false
			for _, item := range r.enum {
				if item == val {
					found = true
				}
			}
			if !found {
				runner.EmitIssue(
					r,
					fmt.Sprintf(`"%s" is an invalid value as default_route_table_propagation`, truncateLongMessage(val)),
					attribute.Expr.Range(),
				)
			}
			return nil
		})
	})
}
