// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"testing"

	"github.com/terraform-linters/tflint/tflint"
)

func Test_AwsEcsTaskDefinitionInvalidIpcModeRule(t *testing.T) {
	cases := []struct {
		Name     string
		Content  string
		Expected tflint.Issues
	}{
		{
			Name: "It includes invalid characters",
			Content: `
resource "aws_ecs_task_definition" "foo" {
	ipc_mode = "vpc"
}`,
			Expected: tflint.Issues{
				{
					Rule:    NewAwsEcsTaskDefinitionInvalidIpcModeRule(),
					Message: `"vpc" is an invalid value as ipc_mode`,
				},
			},
		},
		{
			Name: "It is valid",
			Content: `
resource "aws_ecs_task_definition" "foo" {
	ipc_mode = "host"
}`,
			Expected: tflint.Issues{},
		},
	}

	rule := NewAwsEcsTaskDefinitionInvalidIpcModeRule()

	for _, tc := range cases {
		runner := tflint.TestRunner(t, map[string]string{"resource.tf": tc.Content})

		if err := rule.Check(runner); err != nil {
			t.Fatalf("Unexpected error occurred: %s", err)
		}

		tflint.AssertIssuesWithoutRange(t, tc.Expected, runner.Issues)
	}
}
