// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"fmt"
	"log"
	"regexp"

	hcl "github.com/hashicorp/hcl/v2"
	"github.com/terraform-linters/tflint/tflint"
)

// AwsEfsMountTargetInvalidFileSystemIDRule checks the pattern is valid
type AwsEfsMountTargetInvalidFileSystemIDRule struct {
	resourceType  string
	attributeName string
	max           int
	pattern       *regexp.Regexp
}

// NewAwsEfsMountTargetInvalidFileSystemIDRule returns new rule with default attributes
func NewAwsEfsMountTargetInvalidFileSystemIDRule() *AwsEfsMountTargetInvalidFileSystemIDRule {
	return &AwsEfsMountTargetInvalidFileSystemIDRule{
		resourceType:  "aws_efs_mount_target",
		attributeName: "file_system_id",
		max:           128,
		pattern:       regexp.MustCompile(`^(arn:aws[-a-z]*:elasticfilesystem:[0-9a-z-:]+:file-system/fs-[0-9a-f]{8,40}|fs-[0-9a-f]{8,40})$`),
	}
}

// Name returns the rule name
func (r *AwsEfsMountTargetInvalidFileSystemIDRule) Name() string {
	return "aws_efs_mount_target_invalid_file_system_id"
}

// Enabled returns whether the rule is enabled by default
func (r *AwsEfsMountTargetInvalidFileSystemIDRule) Enabled() bool {
	return true
}

// Severity returns the rule severity
func (r *AwsEfsMountTargetInvalidFileSystemIDRule) Severity() string {
	return tflint.ERROR
}

// Link returns the rule reference link
func (r *AwsEfsMountTargetInvalidFileSystemIDRule) Link() string {
	return ""
}

// Check checks the pattern is valid
func (r *AwsEfsMountTargetInvalidFileSystemIDRule) Check(runner *tflint.Runner) error {
	log.Printf("[TRACE] Check `%s` rule for `%s` runner", r.Name(), runner.TFConfigPath())

	return runner.WalkResourceAttributes(r.resourceType, r.attributeName, func(attribute *hcl.Attribute) error {
		var val string
		err := runner.EvaluateExpr(attribute.Expr, &val)

		return runner.EnsureNoError(err, func() error {
			if len(val) > r.max {
				runner.EmitIssue(
					r,
					"file_system_id must be 128 characters or less",
					attribute.Expr.Range(),
				)
			}
			if !r.pattern.MatchString(val) {
				runner.EmitIssue(
					r,
					fmt.Sprintf(`"%s" does not match valid pattern %s`, truncateLongMessage(val), `^(arn:aws[-a-z]*:elasticfilesystem:[0-9a-z-:]+:file-system/fs-[0-9a-f]{8,40}|fs-[0-9a-f]{8,40})$`),
					attribute.Expr.Range(),
				)
			}
			return nil
		})
	})
}
