// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"fmt"
	"log"
	"regexp"

	hcl "github.com/hashicorp/hcl/v2"
	"github.com/terraform-linters/tflint/tflint"
)

// AwsEfsMountTargetInvalidIPAddressRule checks the pattern is valid
type AwsEfsMountTargetInvalidIPAddressRule struct {
	resourceType  string
	attributeName string
	max           int
	min           int
	pattern       *regexp.Regexp
}

// NewAwsEfsMountTargetInvalidIPAddressRule returns new rule with default attributes
func NewAwsEfsMountTargetInvalidIPAddressRule() *AwsEfsMountTargetInvalidIPAddressRule {
	return &AwsEfsMountTargetInvalidIPAddressRule{
		resourceType:  "aws_efs_mount_target",
		attributeName: "ip_address",
		max:           15,
		min:           7,
		pattern:       regexp.MustCompile(`^[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}$`),
	}
}

// Name returns the rule name
func (r *AwsEfsMountTargetInvalidIPAddressRule) Name() string {
	return "aws_efs_mount_target_invalid_ip_address"
}

// Enabled returns whether the rule is enabled by default
func (r *AwsEfsMountTargetInvalidIPAddressRule) Enabled() bool {
	return true
}

// Severity returns the rule severity
func (r *AwsEfsMountTargetInvalidIPAddressRule) Severity() string {
	return tflint.ERROR
}

// Link returns the rule reference link
func (r *AwsEfsMountTargetInvalidIPAddressRule) Link() string {
	return ""
}

// Check checks the pattern is valid
func (r *AwsEfsMountTargetInvalidIPAddressRule) Check(runner *tflint.Runner) error {
	log.Printf("[TRACE] Check `%s` rule for `%s` runner", r.Name(), runner.TFConfigPath())

	return runner.WalkResourceAttributes(r.resourceType, r.attributeName, func(attribute *hcl.Attribute) error {
		var val string
		err := runner.EvaluateExpr(attribute.Expr, &val)

		return runner.EnsureNoError(err, func() error {
			if len(val) > r.max {
				runner.EmitIssue(
					r,
					"ip_address must be 15 characters or less",
					attribute.Expr.Range(),
				)
			}
			if len(val) < r.min {
				runner.EmitIssue(
					r,
					"ip_address must be 7 characters or higher",
					attribute.Expr.Range(),
				)
			}
			if !r.pattern.MatchString(val) {
				runner.EmitIssue(
					r,
					fmt.Sprintf(`"%s" does not match valid pattern %s`, truncateLongMessage(val), `^[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}$`),
					attribute.Expr.Range(),
				)
			}
			return nil
		})
	})
}
