// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"fmt"
	"log"
	"regexp"

	hcl "github.com/hashicorp/hcl/v2"
	"github.com/terraform-linters/tflint/tflint"
)

// AwsEfsMountTargetInvalidSubnetIDRule checks the pattern is valid
type AwsEfsMountTargetInvalidSubnetIDRule struct {
	resourceType  string
	attributeName string
	max           int
	min           int
	pattern       *regexp.Regexp
}

// NewAwsEfsMountTargetInvalidSubnetIDRule returns new rule with default attributes
func NewAwsEfsMountTargetInvalidSubnetIDRule() *AwsEfsMountTargetInvalidSubnetIDRule {
	return &AwsEfsMountTargetInvalidSubnetIDRule{
		resourceType:  "aws_efs_mount_target",
		attributeName: "subnet_id",
		max:           47,
		min:           15,
		pattern:       regexp.MustCompile(`^subnet-[0-9a-f]{8,40}$`),
	}
}

// Name returns the rule name
func (r *AwsEfsMountTargetInvalidSubnetIDRule) Name() string {
	return "aws_efs_mount_target_invalid_subnet_id"
}

// Enabled returns whether the rule is enabled by default
func (r *AwsEfsMountTargetInvalidSubnetIDRule) Enabled() bool {
	return true
}

// Severity returns the rule severity
func (r *AwsEfsMountTargetInvalidSubnetIDRule) Severity() string {
	return tflint.ERROR
}

// Link returns the rule reference link
func (r *AwsEfsMountTargetInvalidSubnetIDRule) Link() string {
	return ""
}

// Check checks the pattern is valid
func (r *AwsEfsMountTargetInvalidSubnetIDRule) Check(runner *tflint.Runner) error {
	log.Printf("[TRACE] Check `%s` rule for `%s` runner", r.Name(), runner.TFConfigPath())

	return runner.WalkResourceAttributes(r.resourceType, r.attributeName, func(attribute *hcl.Attribute) error {
		var val string
		err := runner.EvaluateExpr(attribute.Expr, &val)

		return runner.EnsureNoError(err, func() error {
			if len(val) > r.max {
				runner.EmitIssue(
					r,
					"subnet_id must be 47 characters or less",
					attribute.Expr.Range(),
				)
			}
			if len(val) < r.min {
				runner.EmitIssue(
					r,
					"subnet_id must be 15 characters or higher",
					attribute.Expr.Range(),
				)
			}
			if !r.pattern.MatchString(val) {
				runner.EmitIssue(
					r,
					fmt.Sprintf(`"%s" does not match valid pattern %s`, truncateLongMessage(val), `^subnet-[0-9a-f]{8,40}$`),
					attribute.Expr.Range(),
				)
			}
			return nil
		})
	})
}
