// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"log"

	hcl "github.com/hashicorp/hcl/v2"
	"github.com/terraform-linters/tflint/tflint"
)

// AwsElasticBeanstalkApplicationVersionInvalidBucketRule checks the pattern is valid
type AwsElasticBeanstalkApplicationVersionInvalidBucketRule struct {
	resourceType  string
	attributeName string
	max           int
}

// NewAwsElasticBeanstalkApplicationVersionInvalidBucketRule returns new rule with default attributes
func NewAwsElasticBeanstalkApplicationVersionInvalidBucketRule() *AwsElasticBeanstalkApplicationVersionInvalidBucketRule {
	return &AwsElasticBeanstalkApplicationVersionInvalidBucketRule{
		resourceType:  "aws_elastic_beanstalk_application_version",
		attributeName: "bucket",
		max:           255,
	}
}

// Name returns the rule name
func (r *AwsElasticBeanstalkApplicationVersionInvalidBucketRule) Name() string {
	return "aws_elastic_beanstalk_application_version_invalid_bucket"
}

// Enabled returns whether the rule is enabled by default
func (r *AwsElasticBeanstalkApplicationVersionInvalidBucketRule) Enabled() bool {
	return true
}

// Severity returns the rule severity
func (r *AwsElasticBeanstalkApplicationVersionInvalidBucketRule) Severity() string {
	return tflint.ERROR
}

// Link returns the rule reference link
func (r *AwsElasticBeanstalkApplicationVersionInvalidBucketRule) Link() string {
	return ""
}

// Check checks the pattern is valid
func (r *AwsElasticBeanstalkApplicationVersionInvalidBucketRule) Check(runner *tflint.Runner) error {
	log.Printf("[TRACE] Check `%s` rule for `%s` runner", r.Name(), runner.TFConfigPath())

	return runner.WalkResourceAttributes(r.resourceType, r.attributeName, func(attribute *hcl.Attribute) error {
		var val string
		err := runner.EvaluateExpr(attribute.Expr, &val)

		return runner.EnsureNoError(err, func() error {
			if len(val) > r.max {
				runner.EmitIssue(
					r,
					"bucket must be 255 characters or less",
					attribute.Expr.Range(),
				)
			}
			return nil
		})
	})
}
