// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"fmt"
	"log"
	"regexp"

	hcl "github.com/hashicorp/hcl/v2"
	"github.com/terraform-linters/tflint/tflint"
)

// AwsElastictranscoderPipelineInvalidInputBucketRule checks the pattern is valid
type AwsElastictranscoderPipelineInvalidInputBucketRule struct {
	resourceType  string
	attributeName string
	pattern       *regexp.Regexp
}

// NewAwsElastictranscoderPipelineInvalidInputBucketRule returns new rule with default attributes
func NewAwsElastictranscoderPipelineInvalidInputBucketRule() *AwsElastictranscoderPipelineInvalidInputBucketRule {
	return &AwsElastictranscoderPipelineInvalidInputBucketRule{
		resourceType:  "aws_elastictranscoder_pipeline",
		attributeName: "input_bucket",
		pattern:       regexp.MustCompile(`^(\w|\.|-){1,255}$`),
	}
}

// Name returns the rule name
func (r *AwsElastictranscoderPipelineInvalidInputBucketRule) Name() string {
	return "aws_elastictranscoder_pipeline_invalid_input_bucket"
}

// Enabled returns whether the rule is enabled by default
func (r *AwsElastictranscoderPipelineInvalidInputBucketRule) Enabled() bool {
	return true
}

// Severity returns the rule severity
func (r *AwsElastictranscoderPipelineInvalidInputBucketRule) Severity() string {
	return tflint.ERROR
}

// Link returns the rule reference link
func (r *AwsElastictranscoderPipelineInvalidInputBucketRule) Link() string {
	return ""
}

// Check checks the pattern is valid
func (r *AwsElastictranscoderPipelineInvalidInputBucketRule) Check(runner *tflint.Runner) error {
	log.Printf("[TRACE] Check `%s` rule for `%s` runner", r.Name(), runner.TFConfigPath())

	return runner.WalkResourceAttributes(r.resourceType, r.attributeName, func(attribute *hcl.Attribute) error {
		var val string
		err := runner.EvaluateExpr(attribute.Expr, &val)

		return runner.EnsureNoError(err, func() error {
			if !r.pattern.MatchString(val) {
				runner.EmitIssue(
					r,
					fmt.Sprintf(`"%s" does not match valid pattern %s`, truncateLongMessage(val), `^(\w|\.|-){1,255}$`),
					attribute.Expr.Range(),
				)
			}
			return nil
		})
	})
}
