// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"testing"

	"github.com/terraform-linters/tflint/tflint"
)

func Test_AwsElastictranscoderPresetInvalidContainerRule(t *testing.T) {
	cases := []struct {
		Name     string
		Content  string
		Expected tflint.Issues
	}{
		{
			Name: "It includes invalid characters",
			Content: `
resource "aws_elastictranscoder_preset" "foo" {
	container = "mp1"
}`,
			Expected: tflint.Issues{
				{
					Rule:    NewAwsElastictranscoderPresetInvalidContainerRule(),
					Message: `"mp1" does not match valid pattern ^(^mp4$)|(^ts$)|(^webm$)|(^mp3$)|(^flac$)|(^oga$)|(^ogg$)|(^fmp4$)|(^mpg$)|(^flv$)|(^gif$)|(^mxf$)|(^wav$)|(^mp2$)$`,
				},
			},
		},
		{
			Name: "It is valid",
			Content: `
resource "aws_elastictranscoder_preset" "foo" {
	container = "mp4"
}`,
			Expected: tflint.Issues{},
		},
	}

	rule := NewAwsElastictranscoderPresetInvalidContainerRule()

	for _, tc := range cases {
		runner := tflint.TestRunner(t, map[string]string{"resource.tf": tc.Content})

		if err := rule.Check(runner); err != nil {
			t.Fatalf("Unexpected error occurred: %s", err)
		}

		tflint.AssertIssuesWithoutRange(t, tc.Expected, runner.Issues)
	}
}
