// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"fmt"
	"log"

	hcl "github.com/hashicorp/hcl/v2"
	"github.com/terraform-linters/tflint/tflint"
)

// AwsGameliftBuildInvalidOperatingSystemRule checks the pattern is valid
type AwsGameliftBuildInvalidOperatingSystemRule struct {
	resourceType  string
	attributeName string
	enum          []string
}

// NewAwsGameliftBuildInvalidOperatingSystemRule returns new rule with default attributes
func NewAwsGameliftBuildInvalidOperatingSystemRule() *AwsGameliftBuildInvalidOperatingSystemRule {
	return &AwsGameliftBuildInvalidOperatingSystemRule{
		resourceType:  "aws_gamelift_build",
		attributeName: "operating_system",
		enum: []string{
			"WINDOWS_2012",
			"AMAZON_LINUX",
			"AMAZON_LINUX_2",
		},
	}
}

// Name returns the rule name
func (r *AwsGameliftBuildInvalidOperatingSystemRule) Name() string {
	return "aws_gamelift_build_invalid_operating_system"
}

// Enabled returns whether the rule is enabled by default
func (r *AwsGameliftBuildInvalidOperatingSystemRule) Enabled() bool {
	return true
}

// Severity returns the rule severity
func (r *AwsGameliftBuildInvalidOperatingSystemRule) Severity() string {
	return tflint.ERROR
}

// Link returns the rule reference link
func (r *AwsGameliftBuildInvalidOperatingSystemRule) Link() string {
	return ""
}

// Check checks the pattern is valid
func (r *AwsGameliftBuildInvalidOperatingSystemRule) Check(runner *tflint.Runner) error {
	log.Printf("[TRACE] Check `%s` rule for `%s` runner", r.Name(), runner.TFConfigPath())

	return runner.WalkResourceAttributes(r.resourceType, r.attributeName, func(attribute *hcl.Attribute) error {
		var val string
		err := runner.EvaluateExpr(attribute.Expr, &val)

		return runner.EnsureNoError(err, func() error {
			found := false
			for _, item := range r.enum {
				if item == val {
					found = true
				}
			}
			if !found {
				runner.EmitIssue(
					r,
					fmt.Sprintf(`"%s" is an invalid value as operating_system`, truncateLongMessage(val)),
					attribute.Expr.Range(),
				)
			}
			return nil
		})
	})
}
