// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"fmt"
	"log"

	hcl "github.com/hashicorp/hcl/v2"
	"github.com/terraform-linters/tflint/tflint"
)

// AwsGameliftFleetInvalidEc2InstanceTypeRule checks the pattern is valid
type AwsGameliftFleetInvalidEc2InstanceTypeRule struct {
	resourceType  string
	attributeName string
	enum          []string
}

// NewAwsGameliftFleetInvalidEc2InstanceTypeRule returns new rule with default attributes
func NewAwsGameliftFleetInvalidEc2InstanceTypeRule() *AwsGameliftFleetInvalidEc2InstanceTypeRule {
	return &AwsGameliftFleetInvalidEc2InstanceTypeRule{
		resourceType:  "aws_gamelift_fleet",
		attributeName: "ec2_instance_type",
		enum: []string{
			"t2.micro",
			"t2.small",
			"t2.medium",
			"t2.large",
			"c3.large",
			"c3.xlarge",
			"c3.2xlarge",
			"c3.4xlarge",
			"c3.8xlarge",
			"c4.large",
			"c4.xlarge",
			"c4.2xlarge",
			"c4.4xlarge",
			"c4.8xlarge",
			"c5.large",
			"c5.xlarge",
			"c5.2xlarge",
			"c5.4xlarge",
			"c5.9xlarge",
			"c5.12xlarge",
			"c5.18xlarge",
			"c5.24xlarge",
			"c5a.large",
			"c5a.xlarge",
			"c5a.2xlarge",
			"c5a.4xlarge",
			"c5a.8xlarge",
			"c5a.12xlarge",
			"c5a.16xlarge",
			"c5a.24xlarge",
			"r3.large",
			"r3.xlarge",
			"r3.2xlarge",
			"r3.4xlarge",
			"r3.8xlarge",
			"r4.large",
			"r4.xlarge",
			"r4.2xlarge",
			"r4.4xlarge",
			"r4.8xlarge",
			"r4.16xlarge",
			"r5.large",
			"r5.xlarge",
			"r5.2xlarge",
			"r5.4xlarge",
			"r5.8xlarge",
			"r5.12xlarge",
			"r5.16xlarge",
			"r5.24xlarge",
			"r5a.large",
			"r5a.xlarge",
			"r5a.2xlarge",
			"r5a.4xlarge",
			"r5a.8xlarge",
			"r5a.12xlarge",
			"r5a.16xlarge",
			"r5a.24xlarge",
			"m3.medium",
			"m3.large",
			"m3.xlarge",
			"m3.2xlarge",
			"m4.large",
			"m4.xlarge",
			"m4.2xlarge",
			"m4.4xlarge",
			"m4.10xlarge",
			"m5.large",
			"m5.xlarge",
			"m5.2xlarge",
			"m5.4xlarge",
			"m5.8xlarge",
			"m5.12xlarge",
			"m5.16xlarge",
			"m5.24xlarge",
			"m5a.large",
			"m5a.xlarge",
			"m5a.2xlarge",
			"m5a.4xlarge",
			"m5a.8xlarge",
			"m5a.12xlarge",
			"m5a.16xlarge",
			"m5a.24xlarge",
		},
	}
}

// Name returns the rule name
func (r *AwsGameliftFleetInvalidEc2InstanceTypeRule) Name() string {
	return "aws_gamelift_fleet_invalid_ec2_instance_type"
}

// Enabled returns whether the rule is enabled by default
func (r *AwsGameliftFleetInvalidEc2InstanceTypeRule) Enabled() bool {
	return true
}

// Severity returns the rule severity
func (r *AwsGameliftFleetInvalidEc2InstanceTypeRule) Severity() string {
	return tflint.ERROR
}

// Link returns the rule reference link
func (r *AwsGameliftFleetInvalidEc2InstanceTypeRule) Link() string {
	return ""
}

// Check checks the pattern is valid
func (r *AwsGameliftFleetInvalidEc2InstanceTypeRule) Check(runner *tflint.Runner) error {
	log.Printf("[TRACE] Check `%s` rule for `%s` runner", r.Name(), runner.TFConfigPath())

	return runner.WalkResourceAttributes(r.resourceType, r.attributeName, func(attribute *hcl.Attribute) error {
		var val string
		err := runner.EvaluateExpr(attribute.Expr, &val)

		return runner.EnsureNoError(err, func() error {
			found := false
			for _, item := range r.enum {
				if item == val {
					found = true
				}
			}
			if !found {
				runner.EmitIssue(
					r,
					fmt.Sprintf(`"%s" is an invalid value as ec2_instance_type`, truncateLongMessage(val)),
					attribute.Expr.Range(),
				)
			}
			return nil
		})
	})
}
