// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"log"

	hcl "github.com/hashicorp/hcl/v2"
	"github.com/terraform-linters/tflint/tflint"
)

// AwsGlobalacceleratorEndpointGroupInvalidHealthCheckPathRule checks the pattern is valid
type AwsGlobalacceleratorEndpointGroupInvalidHealthCheckPathRule struct {
	resourceType  string
	attributeName string
	max           int
}

// NewAwsGlobalacceleratorEndpointGroupInvalidHealthCheckPathRule returns new rule with default attributes
func NewAwsGlobalacceleratorEndpointGroupInvalidHealthCheckPathRule() *AwsGlobalacceleratorEndpointGroupInvalidHealthCheckPathRule {
	return &AwsGlobalacceleratorEndpointGroupInvalidHealthCheckPathRule{
		resourceType:  "aws_globalaccelerator_endpoint_group",
		attributeName: "health_check_path",
		max:           255,
	}
}

// Name returns the rule name
func (r *AwsGlobalacceleratorEndpointGroupInvalidHealthCheckPathRule) Name() string {
	return "aws_globalaccelerator_endpoint_group_invalid_health_check_path"
}

// Enabled returns whether the rule is enabled by default
func (r *AwsGlobalacceleratorEndpointGroupInvalidHealthCheckPathRule) Enabled() bool {
	return true
}

// Severity returns the rule severity
func (r *AwsGlobalacceleratorEndpointGroupInvalidHealthCheckPathRule) Severity() string {
	return tflint.ERROR
}

// Link returns the rule reference link
func (r *AwsGlobalacceleratorEndpointGroupInvalidHealthCheckPathRule) Link() string {
	return ""
}

// Check checks the pattern is valid
func (r *AwsGlobalacceleratorEndpointGroupInvalidHealthCheckPathRule) Check(runner *tflint.Runner) error {
	log.Printf("[TRACE] Check `%s` rule for `%s` runner", r.Name(), runner.TFConfigPath())

	return runner.WalkResourceAttributes(r.resourceType, r.attributeName, func(attribute *hcl.Attribute) error {
		var val string
		err := runner.EvaluateExpr(attribute.Expr, &val)

		return runner.EnsureNoError(err, func() error {
			if len(val) > r.max {
				runner.EmitIssue(
					r,
					"health_check_path must be 255 characters or less",
					attribute.Expr.Range(),
				)
			}
			return nil
		})
	})
}
