// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"log"

	hcl "github.com/hashicorp/hcl/v2"
	"github.com/terraform-linters/tflint/tflint"
)

// AwsGlueCatalogTableInvalidTableTypeRule checks the pattern is valid
type AwsGlueCatalogTableInvalidTableTypeRule struct {
	resourceType  string
	attributeName string
	max           int
}

// NewAwsGlueCatalogTableInvalidTableTypeRule returns new rule with default attributes
func NewAwsGlueCatalogTableInvalidTableTypeRule() *AwsGlueCatalogTableInvalidTableTypeRule {
	return &AwsGlueCatalogTableInvalidTableTypeRule{
		resourceType:  "aws_glue_catalog_table",
		attributeName: "table_type",
		max:           255,
	}
}

// Name returns the rule name
func (r *AwsGlueCatalogTableInvalidTableTypeRule) Name() string {
	return "aws_glue_catalog_table_invalid_table_type"
}

// Enabled returns whether the rule is enabled by default
func (r *AwsGlueCatalogTableInvalidTableTypeRule) Enabled() bool {
	return true
}

// Severity returns the rule severity
func (r *AwsGlueCatalogTableInvalidTableTypeRule) Severity() string {
	return tflint.ERROR
}

// Link returns the rule reference link
func (r *AwsGlueCatalogTableInvalidTableTypeRule) Link() string {
	return ""
}

// Check checks the pattern is valid
func (r *AwsGlueCatalogTableInvalidTableTypeRule) Check(runner *tflint.Runner) error {
	log.Printf("[TRACE] Check `%s` rule for `%s` runner", r.Name(), runner.TFConfigPath())

	return runner.WalkResourceAttributes(r.resourceType, r.attributeName, func(attribute *hcl.Attribute) error {
		var val string
		err := runner.EvaluateExpr(attribute.Expr, &val)

		return runner.EnsureNoError(err, func() error {
			if len(val) > r.max {
				runner.EmitIssue(
					r,
					"table_type must be 255 characters or less",
					attribute.Expr.Range(),
				)
			}
			return nil
		})
	})
}
