// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"fmt"
	"log"

	hcl "github.com/hashicorp/hcl/v2"
	"github.com/terraform-linters/tflint/tflint"
)

// AwsIAMUserSSHKeyInvalidEncodingRule checks the pattern is valid
type AwsIAMUserSSHKeyInvalidEncodingRule struct {
	resourceType  string
	attributeName string
	enum          []string
}

// NewAwsIAMUserSSHKeyInvalidEncodingRule returns new rule with default attributes
func NewAwsIAMUserSSHKeyInvalidEncodingRule() *AwsIAMUserSSHKeyInvalidEncodingRule {
	return &AwsIAMUserSSHKeyInvalidEncodingRule{
		resourceType:  "aws_iam_user_ssh_key",
		attributeName: "encoding",
		enum: []string{
			"SSH",
			"PEM",
		},
	}
}

// Name returns the rule name
func (r *AwsIAMUserSSHKeyInvalidEncodingRule) Name() string {
	return "aws_iam_user_ssh_key_invalid_encoding"
}

// Enabled returns whether the rule is enabled by default
func (r *AwsIAMUserSSHKeyInvalidEncodingRule) Enabled() bool {
	return true
}

// Severity returns the rule severity
func (r *AwsIAMUserSSHKeyInvalidEncodingRule) Severity() string {
	return tflint.ERROR
}

// Link returns the rule reference link
func (r *AwsIAMUserSSHKeyInvalidEncodingRule) Link() string {
	return ""
}

// Check checks the pattern is valid
func (r *AwsIAMUserSSHKeyInvalidEncodingRule) Check(runner *tflint.Runner) error {
	log.Printf("[TRACE] Check `%s` rule for `%s` runner", r.Name(), runner.TFConfigPath())

	return runner.WalkResourceAttributes(r.resourceType, r.attributeName, func(attribute *hcl.Attribute) error {
		var val string
		err := runner.EvaluateExpr(attribute.Expr, &val)

		return runner.EnsureNoError(err, func() error {
			found := false
			for _, item := range r.enum {
				if item == val {
					found = true
				}
			}
			if !found {
				runner.EmitIssue(
					r,
					fmt.Sprintf(`"%s" is an invalid value as encoding`, truncateLongMessage(val)),
					attribute.Expr.Range(),
				)
			}
			return nil
		})
	})
}
