// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"fmt"
	"log"
	"regexp"

	hcl "github.com/hashicorp/hcl/v2"
	"github.com/terraform-linters/tflint/tflint"
)

// AwsKmsGrantInvalidGranteePrincipalRule checks the pattern is valid
type AwsKmsGrantInvalidGranteePrincipalRule struct {
	resourceType  string
	attributeName string
	max           int
	min           int
	pattern       *regexp.Regexp
}

// NewAwsKmsGrantInvalidGranteePrincipalRule returns new rule with default attributes
func NewAwsKmsGrantInvalidGranteePrincipalRule() *AwsKmsGrantInvalidGranteePrincipalRule {
	return &AwsKmsGrantInvalidGranteePrincipalRule{
		resourceType:  "aws_kms_grant",
		attributeName: "grantee_principal",
		max:           256,
		min:           1,
		pattern:       regexp.MustCompile(`^[\w+=,.@:/-]+$`),
	}
}

// Name returns the rule name
func (r *AwsKmsGrantInvalidGranteePrincipalRule) Name() string {
	return "aws_kms_grant_invalid_grantee_principal"
}

// Enabled returns whether the rule is enabled by default
func (r *AwsKmsGrantInvalidGranteePrincipalRule) Enabled() bool {
	return true
}

// Severity returns the rule severity
func (r *AwsKmsGrantInvalidGranteePrincipalRule) Severity() string {
	return tflint.ERROR
}

// Link returns the rule reference link
func (r *AwsKmsGrantInvalidGranteePrincipalRule) Link() string {
	return ""
}

// Check checks the pattern is valid
func (r *AwsKmsGrantInvalidGranteePrincipalRule) Check(runner *tflint.Runner) error {
	log.Printf("[TRACE] Check `%s` rule for `%s` runner", r.Name(), runner.TFConfigPath())

	return runner.WalkResourceAttributes(r.resourceType, r.attributeName, func(attribute *hcl.Attribute) error {
		var val string
		err := runner.EvaluateExpr(attribute.Expr, &val)

		return runner.EnsureNoError(err, func() error {
			if len(val) > r.max {
				runner.EmitIssue(
					r,
					"grantee_principal must be 256 characters or less",
					attribute.Expr.Range(),
				)
			}
			if len(val) < r.min {
				runner.EmitIssue(
					r,
					"grantee_principal must be 1 characters or higher",
					attribute.Expr.Range(),
				)
			}
			if !r.pattern.MatchString(val) {
				runner.EmitIssue(
					r,
					fmt.Sprintf(`"%s" does not match valid pattern %s`, truncateLongMessage(val), `^[\w+=,.@:/-]+$`),
					attribute.Expr.Range(),
				)
			}
			return nil
		})
	})
}
