// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"fmt"
	"log"

	hcl "github.com/hashicorp/hcl/v2"
	"github.com/terraform-linters/tflint/tflint"
)

// AwsKmsKeyInvalidKeyUsageRule checks the pattern is valid
type AwsKmsKeyInvalidKeyUsageRule struct {
	resourceType  string
	attributeName string
	enum          []string
}

// NewAwsKmsKeyInvalidKeyUsageRule returns new rule with default attributes
func NewAwsKmsKeyInvalidKeyUsageRule() *AwsKmsKeyInvalidKeyUsageRule {
	return &AwsKmsKeyInvalidKeyUsageRule{
		resourceType:  "aws_kms_key",
		attributeName: "key_usage",
		enum: []string{
			"SIGN_VERIFY",
			"ENCRYPT_DECRYPT",
		},
	}
}

// Name returns the rule name
func (r *AwsKmsKeyInvalidKeyUsageRule) Name() string {
	return "aws_kms_key_invalid_key_usage"
}

// Enabled returns whether the rule is enabled by default
func (r *AwsKmsKeyInvalidKeyUsageRule) Enabled() bool {
	return true
}

// Severity returns the rule severity
func (r *AwsKmsKeyInvalidKeyUsageRule) Severity() string {
	return tflint.ERROR
}

// Link returns the rule reference link
func (r *AwsKmsKeyInvalidKeyUsageRule) Link() string {
	return ""
}

// Check checks the pattern is valid
func (r *AwsKmsKeyInvalidKeyUsageRule) Check(runner *tflint.Runner) error {
	log.Printf("[TRACE] Check `%s` rule for `%s` runner", r.Name(), runner.TFConfigPath())

	return runner.WalkResourceAttributes(r.resourceType, r.attributeName, func(attribute *hcl.Attribute) error {
		var val string
		err := runner.EvaluateExpr(attribute.Expr, &val)

		return runner.EnsureNoError(err, func() error {
			found := false
			for _, item := range r.enum {
				if item == val {
					found = true
				}
			}
			if !found {
				runner.EmitIssue(
					r,
					fmt.Sprintf(`"%s" is an invalid value as key_usage`, truncateLongMessage(val)),
					attribute.Expr.Range(),
				)
			}
			return nil
		})
	})
}
