// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"fmt"
	"log"
	"regexp"

	hcl "github.com/hashicorp/hcl/v2"
	"github.com/terraform-linters/tflint/tflint"
)

// AwsLambdaLayerVersionInvalidLayerNameRule checks the pattern is valid
type AwsLambdaLayerVersionInvalidLayerNameRule struct {
	resourceType  string
	attributeName string
	max           int
	min           int
	pattern       *regexp.Regexp
}

// NewAwsLambdaLayerVersionInvalidLayerNameRule returns new rule with default attributes
func NewAwsLambdaLayerVersionInvalidLayerNameRule() *AwsLambdaLayerVersionInvalidLayerNameRule {
	return &AwsLambdaLayerVersionInvalidLayerNameRule{
		resourceType:  "aws_lambda_layer_version",
		attributeName: "layer_name",
		max:           140,
		min:           1,
		pattern:       regexp.MustCompile(`^(arn:[a-zA-Z0-9-]+:lambda:[a-zA-Z0-9-]+:\d{12}:layer:[a-zA-Z0-9-_]+)|[a-zA-Z0-9-_]+$`),
	}
}

// Name returns the rule name
func (r *AwsLambdaLayerVersionInvalidLayerNameRule) Name() string {
	return "aws_lambda_layer_version_invalid_layer_name"
}

// Enabled returns whether the rule is enabled by default
func (r *AwsLambdaLayerVersionInvalidLayerNameRule) Enabled() bool {
	return true
}

// Severity returns the rule severity
func (r *AwsLambdaLayerVersionInvalidLayerNameRule) Severity() string {
	return tflint.ERROR
}

// Link returns the rule reference link
func (r *AwsLambdaLayerVersionInvalidLayerNameRule) Link() string {
	return ""
}

// Check checks the pattern is valid
func (r *AwsLambdaLayerVersionInvalidLayerNameRule) Check(runner *tflint.Runner) error {
	log.Printf("[TRACE] Check `%s` rule for `%s` runner", r.Name(), runner.TFConfigPath())

	return runner.WalkResourceAttributes(r.resourceType, r.attributeName, func(attribute *hcl.Attribute) error {
		var val string
		err := runner.EvaluateExpr(attribute.Expr, &val)

		return runner.EnsureNoError(err, func() error {
			if len(val) > r.max {
				runner.EmitIssue(
					r,
					"layer_name must be 140 characters or less",
					attribute.Expr.Range(),
				)
			}
			if len(val) < r.min {
				runner.EmitIssue(
					r,
					"layer_name must be 1 characters or higher",
					attribute.Expr.Range(),
				)
			}
			if !r.pattern.MatchString(val) {
				runner.EmitIssue(
					r,
					fmt.Sprintf(`"%s" does not match valid pattern %s`, truncateLongMessage(val), `^(arn:[a-zA-Z0-9-]+:lambda:[a-zA-Z0-9-]+:\d{12}:layer:[a-zA-Z0-9-_]+)|[a-zA-Z0-9-_]+$`),
					attribute.Expr.Range(),
				)
			}
			return nil
		})
	})
}
