// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"log"

	hcl "github.com/hashicorp/hcl/v2"
	"github.com/terraform-linters/tflint/tflint"
)

// AwsLambdaLayerVersionInvalidLicenseInfoRule checks the pattern is valid
type AwsLambdaLayerVersionInvalidLicenseInfoRule struct {
	resourceType  string
	attributeName string
	max           int
}

// NewAwsLambdaLayerVersionInvalidLicenseInfoRule returns new rule with default attributes
func NewAwsLambdaLayerVersionInvalidLicenseInfoRule() *AwsLambdaLayerVersionInvalidLicenseInfoRule {
	return &AwsLambdaLayerVersionInvalidLicenseInfoRule{
		resourceType:  "aws_lambda_layer_version",
		attributeName: "license_info",
		max:           512,
	}
}

// Name returns the rule name
func (r *AwsLambdaLayerVersionInvalidLicenseInfoRule) Name() string {
	return "aws_lambda_layer_version_invalid_license_info"
}

// Enabled returns whether the rule is enabled by default
func (r *AwsLambdaLayerVersionInvalidLicenseInfoRule) Enabled() bool {
	return true
}

// Severity returns the rule severity
func (r *AwsLambdaLayerVersionInvalidLicenseInfoRule) Severity() string {
	return tflint.ERROR
}

// Link returns the rule reference link
func (r *AwsLambdaLayerVersionInvalidLicenseInfoRule) Link() string {
	return ""
}

// Check checks the pattern is valid
func (r *AwsLambdaLayerVersionInvalidLicenseInfoRule) Check(runner *tflint.Runner) error {
	log.Printf("[TRACE] Check `%s` rule for `%s` runner", r.Name(), runner.TFConfigPath())

	return runner.WalkResourceAttributes(r.resourceType, r.attributeName, func(attribute *hcl.Attribute) error {
		var val string
		err := runner.EvaluateExpr(attribute.Expr, &val)

		return runner.EnsureNoError(err, func() error {
			if len(val) > r.max {
				runner.EmitIssue(
					r,
					"license_info must be 512 characters or less",
					attribute.Expr.Range(),
				)
			}
			return nil
		})
	})
}
