// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"fmt"
	"log"
	"regexp"

	hcl "github.com/hashicorp/hcl/v2"
	"github.com/terraform-linters/tflint/tflint"
)

// AwsLambdaPermissionInvalidActionRule checks the pattern is valid
type AwsLambdaPermissionInvalidActionRule struct {
	resourceType  string
	attributeName string
	pattern       *regexp.Regexp
}

// NewAwsLambdaPermissionInvalidActionRule returns new rule with default attributes
func NewAwsLambdaPermissionInvalidActionRule() *AwsLambdaPermissionInvalidActionRule {
	return &AwsLambdaPermissionInvalidActionRule{
		resourceType:  "aws_lambda_permission",
		attributeName: "action",
		pattern:       regexp.MustCompile(`^(lambda:[*]|lambda:[a-zA-Z]+|[*])$`),
	}
}

// Name returns the rule name
func (r *AwsLambdaPermissionInvalidActionRule) Name() string {
	return "aws_lambda_permission_invalid_action"
}

// Enabled returns whether the rule is enabled by default
func (r *AwsLambdaPermissionInvalidActionRule) Enabled() bool {
	return true
}

// Severity returns the rule severity
func (r *AwsLambdaPermissionInvalidActionRule) Severity() string {
	return tflint.ERROR
}

// Link returns the rule reference link
func (r *AwsLambdaPermissionInvalidActionRule) Link() string {
	return ""
}

// Check checks the pattern is valid
func (r *AwsLambdaPermissionInvalidActionRule) Check(runner *tflint.Runner) error {
	log.Printf("[TRACE] Check `%s` rule for `%s` runner", r.Name(), runner.TFConfigPath())

	return runner.WalkResourceAttributes(r.resourceType, r.attributeName, func(attribute *hcl.Attribute) error {
		var val string
		err := runner.EvaluateExpr(attribute.Expr, &val)

		return runner.EnsureNoError(err, func() error {
			if !r.pattern.MatchString(val) {
				runner.EmitIssue(
					r,
					fmt.Sprintf(`"%s" does not match valid pattern %s`, truncateLongMessage(val), `^(lambda:[*]|lambda:[a-zA-Z]+|[*])$`),
					attribute.Expr.Range(),
				)
			}
			return nil
		})
	})
}
