// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"fmt"
	"log"
	"regexp"

	hcl "github.com/hashicorp/hcl/v2"
	"github.com/terraform-linters/tflint/tflint"
)

// AwsLambdaPermissionInvalidEventSourceTokenRule checks the pattern is valid
type AwsLambdaPermissionInvalidEventSourceTokenRule struct {
	resourceType  string
	attributeName string
	max           int
	pattern       *regexp.Regexp
}

// NewAwsLambdaPermissionInvalidEventSourceTokenRule returns new rule with default attributes
func NewAwsLambdaPermissionInvalidEventSourceTokenRule() *AwsLambdaPermissionInvalidEventSourceTokenRule {
	return &AwsLambdaPermissionInvalidEventSourceTokenRule{
		resourceType:  "aws_lambda_permission",
		attributeName: "event_source_token",
		max:           256,
		pattern:       regexp.MustCompile(`^[a-zA-Z0-9._\-]+$`),
	}
}

// Name returns the rule name
func (r *AwsLambdaPermissionInvalidEventSourceTokenRule) Name() string {
	return "aws_lambda_permission_invalid_event_source_token"
}

// Enabled returns whether the rule is enabled by default
func (r *AwsLambdaPermissionInvalidEventSourceTokenRule) Enabled() bool {
	return true
}

// Severity returns the rule severity
func (r *AwsLambdaPermissionInvalidEventSourceTokenRule) Severity() string {
	return tflint.ERROR
}

// Link returns the rule reference link
func (r *AwsLambdaPermissionInvalidEventSourceTokenRule) Link() string {
	return ""
}

// Check checks the pattern is valid
func (r *AwsLambdaPermissionInvalidEventSourceTokenRule) Check(runner *tflint.Runner) error {
	log.Printf("[TRACE] Check `%s` rule for `%s` runner", r.Name(), runner.TFConfigPath())

	return runner.WalkResourceAttributes(r.resourceType, r.attributeName, func(attribute *hcl.Attribute) error {
		var val string
		err := runner.EvaluateExpr(attribute.Expr, &val)

		return runner.EnsureNoError(err, func() error {
			if len(val) > r.max {
				runner.EmitIssue(
					r,
					"event_source_token must be 256 characters or less",
					attribute.Expr.Range(),
				)
			}
			if !r.pattern.MatchString(val) {
				runner.EmitIssue(
					r,
					fmt.Sprintf(`"%s" does not match valid pattern %s`, truncateLongMessage(val), `^[a-zA-Z0-9._\-]+$`),
					attribute.Expr.Range(),
				)
			}
			return nil
		})
	})
}
