// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"testing"

	"github.com/terraform-linters/tflint/tflint"
)

func Test_AwsLaunchTemplateInvalidInstanceTypeRule(t *testing.T) {
	cases := []struct {
		Name     string
		Content  string
		Expected tflint.Issues
	}{
		{
			Name: "It includes invalid characters",
			Content: `
resource "aws_launch_template" "foo" {
	instance_type = "t1.2xlarge"
}`,
			Expected: tflint.Issues{
				{
					Rule:    NewAwsLaunchTemplateInvalidInstanceTypeRule(),
					Message: `"t1.2xlarge" is an invalid value as instance_type`,
				},
			},
		},
		{
			Name: "It is valid",
			Content: `
resource "aws_launch_template" "foo" {
	instance_type = "t2.micro"
}`,
			Expected: tflint.Issues{},
		},
	}

	rule := NewAwsLaunchTemplateInvalidInstanceTypeRule()

	for _, tc := range cases {
		runner := tflint.TestRunner(t, map[string]string{"resource.tf": tc.Content})

		if err := rule.Check(runner); err != nil {
			t.Fatalf("Unexpected error occurred: %s", err)
		}

		tflint.AssertIssuesWithoutRange(t, tc.Expected, runner.Issues)
	}
}
