// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"fmt"
	"log"
	"regexp"

	hcl "github.com/hashicorp/hcl/v2"
	"github.com/terraform-linters/tflint/tflint"
)

// AwsLightsailStaticIPAttachmentInvalidStaticIPNameRule checks the pattern is valid
type AwsLightsailStaticIPAttachmentInvalidStaticIPNameRule struct {
	resourceType  string
	attributeName string
	pattern       *regexp.Regexp
}

// NewAwsLightsailStaticIPAttachmentInvalidStaticIPNameRule returns new rule with default attributes
func NewAwsLightsailStaticIPAttachmentInvalidStaticIPNameRule() *AwsLightsailStaticIPAttachmentInvalidStaticIPNameRule {
	return &AwsLightsailStaticIPAttachmentInvalidStaticIPNameRule{
		resourceType:  "aws_lightsail_static_ip_attachment",
		attributeName: "static_ip_name",
		pattern:       regexp.MustCompile(`^\w[\w\-]*\w$`),
	}
}

// Name returns the rule name
func (r *AwsLightsailStaticIPAttachmentInvalidStaticIPNameRule) Name() string {
	return "aws_lightsail_static_ip_attachment_invalid_static_ip_name"
}

// Enabled returns whether the rule is enabled by default
func (r *AwsLightsailStaticIPAttachmentInvalidStaticIPNameRule) Enabled() bool {
	return true
}

// Severity returns the rule severity
func (r *AwsLightsailStaticIPAttachmentInvalidStaticIPNameRule) Severity() string {
	return tflint.ERROR
}

// Link returns the rule reference link
func (r *AwsLightsailStaticIPAttachmentInvalidStaticIPNameRule) Link() string {
	return ""
}

// Check checks the pattern is valid
func (r *AwsLightsailStaticIPAttachmentInvalidStaticIPNameRule) Check(runner *tflint.Runner) error {
	log.Printf("[TRACE] Check `%s` rule for `%s` runner", r.Name(), runner.TFConfigPath())

	return runner.WalkResourceAttributes(r.resourceType, r.attributeName, func(attribute *hcl.Attribute) error {
		var val string
		err := runner.EvaluateExpr(attribute.Expr, &val)

		return runner.EnsureNoError(err, func() error {
			if !r.pattern.MatchString(val) {
				runner.EmitIssue(
					r,
					fmt.Sprintf(`"%s" does not match valid pattern %s`, truncateLongMessage(val), `^\w[\w\-]*\w$`),
					attribute.Expr.Range(),
				)
			}
			return nil
		})
	})
}
