// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"fmt"
	"log"

	hcl "github.com/hashicorp/hcl/v2"
	"github.com/terraform-linters/tflint/tflint"
)

// AwsOrganizationsOrganizationInvalidFeatureSetRule checks the pattern is valid
type AwsOrganizationsOrganizationInvalidFeatureSetRule struct {
	resourceType  string
	attributeName string
	enum          []string
}

// NewAwsOrganizationsOrganizationInvalidFeatureSetRule returns new rule with default attributes
func NewAwsOrganizationsOrganizationInvalidFeatureSetRule() *AwsOrganizationsOrganizationInvalidFeatureSetRule {
	return &AwsOrganizationsOrganizationInvalidFeatureSetRule{
		resourceType:  "aws_organizations_organization",
		attributeName: "feature_set",
		enum: []string{
			"ALL",
			"CONSOLIDATED_BILLING",
		},
	}
}

// Name returns the rule name
func (r *AwsOrganizationsOrganizationInvalidFeatureSetRule) Name() string {
	return "aws_organizations_organization_invalid_feature_set"
}

// Enabled returns whether the rule is enabled by default
func (r *AwsOrganizationsOrganizationInvalidFeatureSetRule) Enabled() bool {
	return true
}

// Severity returns the rule severity
func (r *AwsOrganizationsOrganizationInvalidFeatureSetRule) Severity() string {
	return tflint.ERROR
}

// Link returns the rule reference link
func (r *AwsOrganizationsOrganizationInvalidFeatureSetRule) Link() string {
	return ""
}

// Check checks the pattern is valid
func (r *AwsOrganizationsOrganizationInvalidFeatureSetRule) Check(runner *tflint.Runner) error {
	log.Printf("[TRACE] Check `%s` rule for `%s` runner", r.Name(), runner.TFConfigPath())

	return runner.WalkResourceAttributes(r.resourceType, r.attributeName, func(attribute *hcl.Attribute) error {
		var val string
		err := runner.EvaluateExpr(attribute.Expr, &val)

		return runner.EnsureNoError(err, func() error {
			found := false
			for _, item := range r.enum {
				if item == val {
					found = true
				}
			}
			if !found {
				runner.EmitIssue(
					r,
					fmt.Sprintf(`"%s" is an invalid value as feature_set`, truncateLongMessage(val)),
					attribute.Expr.Range(),
				)
			}
			return nil
		})
	})
}
