// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"fmt"
	"log"
	"regexp"

	hcl "github.com/hashicorp/hcl/v2"
	"github.com/terraform-linters/tflint/tflint"
)

// AwsOrganizationsOrganizationalUnitInvalidParentIDRule checks the pattern is valid
type AwsOrganizationsOrganizationalUnitInvalidParentIDRule struct {
	resourceType  string
	attributeName string
	max           int
	pattern       *regexp.Regexp
}

// NewAwsOrganizationsOrganizationalUnitInvalidParentIDRule returns new rule with default attributes
func NewAwsOrganizationsOrganizationalUnitInvalidParentIDRule() *AwsOrganizationsOrganizationalUnitInvalidParentIDRule {
	return &AwsOrganizationsOrganizationalUnitInvalidParentIDRule{
		resourceType:  "aws_organizations_organizational_unit",
		attributeName: "parent_id",
		max:           100,
		pattern:       regexp.MustCompile(`^(r-[0-9a-z]{4,32})|(ou-[0-9a-z]{4,32}-[a-z0-9]{8,32})$`),
	}
}

// Name returns the rule name
func (r *AwsOrganizationsOrganizationalUnitInvalidParentIDRule) Name() string {
	return "aws_organizations_organizational_unit_invalid_parent_id"
}

// Enabled returns whether the rule is enabled by default
func (r *AwsOrganizationsOrganizationalUnitInvalidParentIDRule) Enabled() bool {
	return true
}

// Severity returns the rule severity
func (r *AwsOrganizationsOrganizationalUnitInvalidParentIDRule) Severity() string {
	return tflint.ERROR
}

// Link returns the rule reference link
func (r *AwsOrganizationsOrganizationalUnitInvalidParentIDRule) Link() string {
	return ""
}

// Check checks the pattern is valid
func (r *AwsOrganizationsOrganizationalUnitInvalidParentIDRule) Check(runner *tflint.Runner) error {
	log.Printf("[TRACE] Check `%s` rule for `%s` runner", r.Name(), runner.TFConfigPath())

	return runner.WalkResourceAttributes(r.resourceType, r.attributeName, func(attribute *hcl.Attribute) error {
		var val string
		err := runner.EvaluateExpr(attribute.Expr, &val)

		return runner.EnsureNoError(err, func() error {
			if len(val) > r.max {
				runner.EmitIssue(
					r,
					"parent_id must be 100 characters or less",
					attribute.Expr.Range(),
				)
			}
			if !r.pattern.MatchString(val) {
				runner.EmitIssue(
					r,
					fmt.Sprintf(`"%s" does not match valid pattern %s`, truncateLongMessage(val), `^(r-[0-9a-z]{4,32})|(ou-[0-9a-z]{4,32}-[a-z0-9]{8,32})$`),
					attribute.Expr.Range(),
				)
			}
			return nil
		})
	})
}
