// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"fmt"
	"log"

	hcl "github.com/hashicorp/hcl/v2"
	"github.com/terraform-linters/tflint/tflint"
)

// AwsOrganizationsPolicyInvalidTypeRule checks the pattern is valid
type AwsOrganizationsPolicyInvalidTypeRule struct {
	resourceType  string
	attributeName string
	enum          []string
}

// NewAwsOrganizationsPolicyInvalidTypeRule returns new rule with default attributes
func NewAwsOrganizationsPolicyInvalidTypeRule() *AwsOrganizationsPolicyInvalidTypeRule {
	return &AwsOrganizationsPolicyInvalidTypeRule{
		resourceType:  "aws_organizations_policy",
		attributeName: "type",
		enum: []string{
			"SERVICE_CONTROL_POLICY",
			"TAG_POLICY",
			"BACKUP_POLICY",
			"AISERVICES_OPT_OUT_POLICY",
		},
	}
}

// Name returns the rule name
func (r *AwsOrganizationsPolicyInvalidTypeRule) Name() string {
	return "aws_organizations_policy_invalid_type"
}

// Enabled returns whether the rule is enabled by default
func (r *AwsOrganizationsPolicyInvalidTypeRule) Enabled() bool {
	return true
}

// Severity returns the rule severity
func (r *AwsOrganizationsPolicyInvalidTypeRule) Severity() string {
	return tflint.ERROR
}

// Link returns the rule reference link
func (r *AwsOrganizationsPolicyInvalidTypeRule) Link() string {
	return ""
}

// Check checks the pattern is valid
func (r *AwsOrganizationsPolicyInvalidTypeRule) Check(runner *tflint.Runner) error {
	log.Printf("[TRACE] Check `%s` rule for `%s` runner", r.Name(), runner.TFConfigPath())

	return runner.WalkResourceAttributes(r.resourceType, r.attributeName, func(attribute *hcl.Attribute) error {
		var val string
		err := runner.EvaluateExpr(attribute.Expr, &val)

		return runner.EnsureNoError(err, func() error {
			found := false
			for _, item := range r.enum {
				if item == val {
					found = true
				}
			}
			if !found {
				runner.EmitIssue(
					r,
					fmt.Sprintf(`"%s" is an invalid value as type`, truncateLongMessage(val)),
					attribute.Expr.Range(),
				)
			}
			return nil
		})
	})
}
