// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"log"

	hcl "github.com/hashicorp/hcl/v2"
	"github.com/terraform-linters/tflint/tflint"
)

// AwsQuicksightGroupInvalidDescriptionRule checks the pattern is valid
type AwsQuicksightGroupInvalidDescriptionRule struct {
	resourceType  string
	attributeName string
	max           int
	min           int
}

// NewAwsQuicksightGroupInvalidDescriptionRule returns new rule with default attributes
func NewAwsQuicksightGroupInvalidDescriptionRule() *AwsQuicksightGroupInvalidDescriptionRule {
	return &AwsQuicksightGroupInvalidDescriptionRule{
		resourceType:  "aws_quicksight_group",
		attributeName: "description",
		max:           512,
		min:           1,
	}
}

// Name returns the rule name
func (r *AwsQuicksightGroupInvalidDescriptionRule) Name() string {
	return "aws_quicksight_group_invalid_description"
}

// Enabled returns whether the rule is enabled by default
func (r *AwsQuicksightGroupInvalidDescriptionRule) Enabled() bool {
	return true
}

// Severity returns the rule severity
func (r *AwsQuicksightGroupInvalidDescriptionRule) Severity() string {
	return tflint.ERROR
}

// Link returns the rule reference link
func (r *AwsQuicksightGroupInvalidDescriptionRule) Link() string {
	return ""
}

// Check checks the pattern is valid
func (r *AwsQuicksightGroupInvalidDescriptionRule) Check(runner *tflint.Runner) error {
	log.Printf("[TRACE] Check `%s` rule for `%s` runner", r.Name(), runner.TFConfigPath())

	return runner.WalkResourceAttributes(r.resourceType, r.attributeName, func(attribute *hcl.Attribute) error {
		var val string
		err := runner.EvaluateExpr(attribute.Expr, &val)

		return runner.EnsureNoError(err, func() error {
			if len(val) > r.max {
				runner.EmitIssue(
					r,
					"description must be 512 characters or less",
					attribute.Expr.Range(),
				)
			}
			if len(val) < r.min {
				runner.EmitIssue(
					r,
					"description must be 1 characters or higher",
					attribute.Expr.Range(),
				)
			}
			return nil
		})
	})
}
