// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"fmt"
	"log"
	"regexp"

	hcl "github.com/hashicorp/hcl/v2"
	"github.com/terraform-linters/tflint/tflint"
)

// AwsQuicksightGroupInvalidNamespaceRule checks the pattern is valid
type AwsQuicksightGroupInvalidNamespaceRule struct {
	resourceType  string
	attributeName string
	max           int
	pattern       *regexp.Regexp
}

// NewAwsQuicksightGroupInvalidNamespaceRule returns new rule with default attributes
func NewAwsQuicksightGroupInvalidNamespaceRule() *AwsQuicksightGroupInvalidNamespaceRule {
	return &AwsQuicksightGroupInvalidNamespaceRule{
		resourceType:  "aws_quicksight_group",
		attributeName: "namespace",
		max:           64,
		pattern:       regexp.MustCompile(`^[a-zA-Z0-9._-]*$`),
	}
}

// Name returns the rule name
func (r *AwsQuicksightGroupInvalidNamespaceRule) Name() string {
	return "aws_quicksight_group_invalid_namespace"
}

// Enabled returns whether the rule is enabled by default
func (r *AwsQuicksightGroupInvalidNamespaceRule) Enabled() bool {
	return true
}

// Severity returns the rule severity
func (r *AwsQuicksightGroupInvalidNamespaceRule) Severity() string {
	return tflint.ERROR
}

// Link returns the rule reference link
func (r *AwsQuicksightGroupInvalidNamespaceRule) Link() string {
	return ""
}

// Check checks the pattern is valid
func (r *AwsQuicksightGroupInvalidNamespaceRule) Check(runner *tflint.Runner) error {
	log.Printf("[TRACE] Check `%s` rule for `%s` runner", r.Name(), runner.TFConfigPath())

	return runner.WalkResourceAttributes(r.resourceType, r.attributeName, func(attribute *hcl.Attribute) error {
		var val string
		err := runner.EvaluateExpr(attribute.Expr, &val)

		return runner.EnsureNoError(err, func() error {
			if len(val) > r.max {
				runner.EmitIssue(
					r,
					"namespace must be 64 characters or less",
					attribute.Expr.Range(),
				)
			}
			if !r.pattern.MatchString(val) {
				runner.EmitIssue(
					r,
					fmt.Sprintf(`"%s" does not match valid pattern %s`, truncateLongMessage(val), `^[a-zA-Z0-9._-]*$`),
					attribute.Expr.Range(),
				)
			}
			return nil
		})
	})
}
