// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"log"

	hcl "github.com/hashicorp/hcl/v2"
	"github.com/terraform-linters/tflint/tflint"
)

// AwsRoute53RecordInvalidHealthCheckIDRule checks the pattern is valid
type AwsRoute53RecordInvalidHealthCheckIDRule struct {
	resourceType  string
	attributeName string
	max           int
}

// NewAwsRoute53RecordInvalidHealthCheckIDRule returns new rule with default attributes
func NewAwsRoute53RecordInvalidHealthCheckIDRule() *AwsRoute53RecordInvalidHealthCheckIDRule {
	return &AwsRoute53RecordInvalidHealthCheckIDRule{
		resourceType:  "aws_route53_record",
		attributeName: "health_check_id",
		max:           64,
	}
}

// Name returns the rule name
func (r *AwsRoute53RecordInvalidHealthCheckIDRule) Name() string {
	return "aws_route53_record_invalid_health_check_id"
}

// Enabled returns whether the rule is enabled by default
func (r *AwsRoute53RecordInvalidHealthCheckIDRule) Enabled() bool {
	return true
}

// Severity returns the rule severity
func (r *AwsRoute53RecordInvalidHealthCheckIDRule) Severity() string {
	return tflint.ERROR
}

// Link returns the rule reference link
func (r *AwsRoute53RecordInvalidHealthCheckIDRule) Link() string {
	return ""
}

// Check checks the pattern is valid
func (r *AwsRoute53RecordInvalidHealthCheckIDRule) Check(runner *tflint.Runner) error {
	log.Printf("[TRACE] Check `%s` rule for `%s` runner", r.Name(), runner.TFConfigPath())

	return runner.WalkResourceAttributes(r.resourceType, r.attributeName, func(attribute *hcl.Attribute) error {
		var val string
		err := runner.EvaluateExpr(attribute.Expr, &val)

		return runner.EnsureNoError(err, func() error {
			if len(val) > r.max {
				runner.EmitIssue(
					r,
					"health_check_id must be 64 characters or less",
					attribute.Expr.Range(),
				)
			}
			return nil
		})
	})
}
