// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"fmt"
	"log"

	hcl "github.com/hashicorp/hcl/v2"
	"github.com/terraform-linters/tflint/tflint"
)

// AwsS3BucketInventoryInvalidIncludedObjectVersionsRule checks the pattern is valid
type AwsS3BucketInventoryInvalidIncludedObjectVersionsRule struct {
	resourceType  string
	attributeName string
	enum          []string
}

// NewAwsS3BucketInventoryInvalidIncludedObjectVersionsRule returns new rule with default attributes
func NewAwsS3BucketInventoryInvalidIncludedObjectVersionsRule() *AwsS3BucketInventoryInvalidIncludedObjectVersionsRule {
	return &AwsS3BucketInventoryInvalidIncludedObjectVersionsRule{
		resourceType:  "aws_s3_bucket_inventory",
		attributeName: "included_object_versions",
		enum: []string{
			"All",
			"Current",
		},
	}
}

// Name returns the rule name
func (r *AwsS3BucketInventoryInvalidIncludedObjectVersionsRule) Name() string {
	return "aws_s3_bucket_inventory_invalid_included_object_versions"
}

// Enabled returns whether the rule is enabled by default
func (r *AwsS3BucketInventoryInvalidIncludedObjectVersionsRule) Enabled() bool {
	return true
}

// Severity returns the rule severity
func (r *AwsS3BucketInventoryInvalidIncludedObjectVersionsRule) Severity() string {
	return tflint.ERROR
}

// Link returns the rule reference link
func (r *AwsS3BucketInventoryInvalidIncludedObjectVersionsRule) Link() string {
	return ""
}

// Check checks the pattern is valid
func (r *AwsS3BucketInventoryInvalidIncludedObjectVersionsRule) Check(runner *tflint.Runner) error {
	log.Printf("[TRACE] Check `%s` rule for `%s` runner", r.Name(), runner.TFConfigPath())

	return runner.WalkResourceAttributes(r.resourceType, r.attributeName, func(attribute *hcl.Attribute) error {
		var val string
		err := runner.EvaluateExpr(attribute.Expr, &val)

		return runner.EnsureNoError(err, func() error {
			found := false
			for _, item := range r.enum {
				if item == val {
					found = true
				}
			}
			if !found {
				runner.EmitIssue(
					r,
					fmt.Sprintf(`"%s" is an invalid value as included_object_versions`, truncateLongMessage(val)),
					attribute.Expr.Range(),
				)
			}
			return nil
		})
	})
}
