// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"fmt"
	"log"
	"regexp"

	hcl "github.com/hashicorp/hcl/v2"
	"github.com/terraform-linters/tflint/tflint"
)

// AwsSagemakerEndpointConfigurationInvalidKmsKeyArnRule checks the pattern is valid
type AwsSagemakerEndpointConfigurationInvalidKmsKeyArnRule struct {
	resourceType  string
	attributeName string
	max           int
	pattern       *regexp.Regexp
}

// NewAwsSagemakerEndpointConfigurationInvalidKmsKeyArnRule returns new rule with default attributes
func NewAwsSagemakerEndpointConfigurationInvalidKmsKeyArnRule() *AwsSagemakerEndpointConfigurationInvalidKmsKeyArnRule {
	return &AwsSagemakerEndpointConfigurationInvalidKmsKeyArnRule{
		resourceType:  "aws_sagemaker_endpoint_configuration",
		attributeName: "kms_key_arn",
		max:           2048,
		pattern:       regexp.MustCompile(`^.*$`),
	}
}

// Name returns the rule name
func (r *AwsSagemakerEndpointConfigurationInvalidKmsKeyArnRule) Name() string {
	return "aws_sagemaker_endpoint_configuration_invalid_kms_key_arn"
}

// Enabled returns whether the rule is enabled by default
func (r *AwsSagemakerEndpointConfigurationInvalidKmsKeyArnRule) Enabled() bool {
	return true
}

// Severity returns the rule severity
func (r *AwsSagemakerEndpointConfigurationInvalidKmsKeyArnRule) Severity() string {
	return tflint.ERROR
}

// Link returns the rule reference link
func (r *AwsSagemakerEndpointConfigurationInvalidKmsKeyArnRule) Link() string {
	return ""
}

// Check checks the pattern is valid
func (r *AwsSagemakerEndpointConfigurationInvalidKmsKeyArnRule) Check(runner *tflint.Runner) error {
	log.Printf("[TRACE] Check `%s` rule for `%s` runner", r.Name(), runner.TFConfigPath())

	return runner.WalkResourceAttributes(r.resourceType, r.attributeName, func(attribute *hcl.Attribute) error {
		var val string
		err := runner.EvaluateExpr(attribute.Expr, &val)

		return runner.EnsureNoError(err, func() error {
			if len(val) > r.max {
				runner.EmitIssue(
					r,
					"kms_key_arn must be 2048 characters or less",
					attribute.Expr.Range(),
				)
			}
			if !r.pattern.MatchString(val) {
				runner.EmitIssue(
					r,
					fmt.Sprintf(`"%s" does not match valid pattern %s`, truncateLongMessage(val), `^.*$`),
					attribute.Expr.Range(),
				)
			}
			return nil
		})
	})
}
