// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"fmt"
	"log"
	"regexp"

	hcl "github.com/hashicorp/hcl/v2"
	"github.com/terraform-linters/tflint/tflint"
)

// AwsSagemakerEndpointInvalidEndpointConfigNameRule checks the pattern is valid
type AwsSagemakerEndpointInvalidEndpointConfigNameRule struct {
	resourceType  string
	attributeName string
	max           int
	pattern       *regexp.Regexp
}

// NewAwsSagemakerEndpointInvalidEndpointConfigNameRule returns new rule with default attributes
func NewAwsSagemakerEndpointInvalidEndpointConfigNameRule() *AwsSagemakerEndpointInvalidEndpointConfigNameRule {
	return &AwsSagemakerEndpointInvalidEndpointConfigNameRule{
		resourceType:  "aws_sagemaker_endpoint",
		attributeName: "endpoint_config_name",
		max:           63,
		pattern:       regexp.MustCompile(`^[a-zA-Z0-9](-*[a-zA-Z0-9]){0,62}`),
	}
}

// Name returns the rule name
func (r *AwsSagemakerEndpointInvalidEndpointConfigNameRule) Name() string {
	return "aws_sagemaker_endpoint_invalid_endpoint_config_name"
}

// Enabled returns whether the rule is enabled by default
func (r *AwsSagemakerEndpointInvalidEndpointConfigNameRule) Enabled() bool {
	return true
}

// Severity returns the rule severity
func (r *AwsSagemakerEndpointInvalidEndpointConfigNameRule) Severity() string {
	return tflint.ERROR
}

// Link returns the rule reference link
func (r *AwsSagemakerEndpointInvalidEndpointConfigNameRule) Link() string {
	return ""
}

// Check checks the pattern is valid
func (r *AwsSagemakerEndpointInvalidEndpointConfigNameRule) Check(runner *tflint.Runner) error {
	log.Printf("[TRACE] Check `%s` rule for `%s` runner", r.Name(), runner.TFConfigPath())

	return runner.WalkResourceAttributes(r.resourceType, r.attributeName, func(attribute *hcl.Attribute) error {
		var val string
		err := runner.EvaluateExpr(attribute.Expr, &val)

		return runner.EnsureNoError(err, func() error {
			if len(val) > r.max {
				runner.EmitIssue(
					r,
					"endpoint_config_name must be 63 characters or less",
					attribute.Expr.Range(),
				)
			}
			if !r.pattern.MatchString(val) {
				runner.EmitIssue(
					r,
					fmt.Sprintf(`"%s" does not match valid pattern %s`, truncateLongMessage(val), `^[a-zA-Z0-9](-*[a-zA-Z0-9]){0,62}`),
					attribute.Expr.Range(),
				)
			}
			return nil
		})
	})
}
