// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"fmt"
	"log"
	"regexp"

	hcl "github.com/hashicorp/hcl/v2"
	"github.com/terraform-linters/tflint/tflint"
)

// AwsSagemakerNotebookInstanceInvalidSubnetIDRule checks the pattern is valid
type AwsSagemakerNotebookInstanceInvalidSubnetIDRule struct {
	resourceType  string
	attributeName string
	max           int
	pattern       *regexp.Regexp
}

// NewAwsSagemakerNotebookInstanceInvalidSubnetIDRule returns new rule with default attributes
func NewAwsSagemakerNotebookInstanceInvalidSubnetIDRule() *AwsSagemakerNotebookInstanceInvalidSubnetIDRule {
	return &AwsSagemakerNotebookInstanceInvalidSubnetIDRule{
		resourceType:  "aws_sagemaker_notebook_instance",
		attributeName: "subnet_id",
		max:           32,
		pattern:       regexp.MustCompile(`^[-0-9a-zA-Z]+$`),
	}
}

// Name returns the rule name
func (r *AwsSagemakerNotebookInstanceInvalidSubnetIDRule) Name() string {
	return "aws_sagemaker_notebook_instance_invalid_subnet_id"
}

// Enabled returns whether the rule is enabled by default
func (r *AwsSagemakerNotebookInstanceInvalidSubnetIDRule) Enabled() bool {
	return true
}

// Severity returns the rule severity
func (r *AwsSagemakerNotebookInstanceInvalidSubnetIDRule) Severity() string {
	return tflint.ERROR
}

// Link returns the rule reference link
func (r *AwsSagemakerNotebookInstanceInvalidSubnetIDRule) Link() string {
	return ""
}

// Check checks the pattern is valid
func (r *AwsSagemakerNotebookInstanceInvalidSubnetIDRule) Check(runner *tflint.Runner) error {
	log.Printf("[TRACE] Check `%s` rule for `%s` runner", r.Name(), runner.TFConfigPath())

	return runner.WalkResourceAttributes(r.resourceType, r.attributeName, func(attribute *hcl.Attribute) error {
		var val string
		err := runner.EvaluateExpr(attribute.Expr, &val)

		return runner.EnsureNoError(err, func() error {
			if len(val) > r.max {
				runner.EmitIssue(
					r,
					"subnet_id must be 32 characters or less",
					attribute.Expr.Range(),
				)
			}
			if !r.pattern.MatchString(val) {
				runner.EmitIssue(
					r,
					fmt.Sprintf(`"%s" does not match valid pattern %s`, truncateLongMessage(val), `^[-0-9a-zA-Z]+$`),
					attribute.Expr.Range(),
				)
			}
			return nil
		})
	})
}
