// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"log"

	hcl "github.com/hashicorp/hcl/v2"
	"github.com/terraform-linters/tflint/tflint"
)

// AwsSecretsmanagerSecretInvalidRotationLambdaArnRule checks the pattern is valid
type AwsSecretsmanagerSecretInvalidRotationLambdaArnRule struct {
	resourceType  string
	attributeName string
	max           int
}

// NewAwsSecretsmanagerSecretInvalidRotationLambdaArnRule returns new rule with default attributes
func NewAwsSecretsmanagerSecretInvalidRotationLambdaArnRule() *AwsSecretsmanagerSecretInvalidRotationLambdaArnRule {
	return &AwsSecretsmanagerSecretInvalidRotationLambdaArnRule{
		resourceType:  "aws_secretsmanager_secret",
		attributeName: "rotation_lambda_arn",
		max:           2048,
	}
}

// Name returns the rule name
func (r *AwsSecretsmanagerSecretInvalidRotationLambdaArnRule) Name() string {
	return "aws_secretsmanager_secret_invalid_rotation_lambda_arn"
}

// Enabled returns whether the rule is enabled by default
func (r *AwsSecretsmanagerSecretInvalidRotationLambdaArnRule) Enabled() bool {
	return true
}

// Severity returns the rule severity
func (r *AwsSecretsmanagerSecretInvalidRotationLambdaArnRule) Severity() string {
	return tflint.ERROR
}

// Link returns the rule reference link
func (r *AwsSecretsmanagerSecretInvalidRotationLambdaArnRule) Link() string {
	return ""
}

// Check checks the pattern is valid
func (r *AwsSecretsmanagerSecretInvalidRotationLambdaArnRule) Check(runner *tflint.Runner) error {
	log.Printf("[TRACE] Check `%s` rule for `%s` runner", r.Name(), runner.TFConfigPath())

	return runner.WalkResourceAttributes(r.resourceType, r.attributeName, func(attribute *hcl.Attribute) error {
		var val string
		err := runner.EvaluateExpr(attribute.Expr, &val)

		return runner.EnsureNoError(err, func() error {
			if len(val) > r.max {
				runner.EmitIssue(
					r,
					"rotation_lambda_arn must be 2048 characters or less",
					attribute.Expr.Range(),
				)
			}
			return nil
		})
	})
}
