// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"fmt"
	"log"

	hcl "github.com/hashicorp/hcl/v2"
	"github.com/terraform-linters/tflint/tflint"
)

// AwsSesDomainMailFromInvalidBehaviorOnMxFailureRule checks the pattern is valid
type AwsSesDomainMailFromInvalidBehaviorOnMxFailureRule struct {
	resourceType  string
	attributeName string
	enum          []string
}

// NewAwsSesDomainMailFromInvalidBehaviorOnMxFailureRule returns new rule with default attributes
func NewAwsSesDomainMailFromInvalidBehaviorOnMxFailureRule() *AwsSesDomainMailFromInvalidBehaviorOnMxFailureRule {
	return &AwsSesDomainMailFromInvalidBehaviorOnMxFailureRule{
		resourceType:  "aws_ses_domain_mail_from",
		attributeName: "behavior_on_mx_failure",
		enum: []string{
			"UseDefaultValue",
			"RejectMessage",
		},
	}
}

// Name returns the rule name
func (r *AwsSesDomainMailFromInvalidBehaviorOnMxFailureRule) Name() string {
	return "aws_ses_domain_mail_from_invalid_behavior_on_mx_failure"
}

// Enabled returns whether the rule is enabled by default
func (r *AwsSesDomainMailFromInvalidBehaviorOnMxFailureRule) Enabled() bool {
	return true
}

// Severity returns the rule severity
func (r *AwsSesDomainMailFromInvalidBehaviorOnMxFailureRule) Severity() string {
	return tflint.ERROR
}

// Link returns the rule reference link
func (r *AwsSesDomainMailFromInvalidBehaviorOnMxFailureRule) Link() string {
	return ""
}

// Check checks the pattern is valid
func (r *AwsSesDomainMailFromInvalidBehaviorOnMxFailureRule) Check(runner *tflint.Runner) error {
	log.Printf("[TRACE] Check `%s` rule for `%s` runner", r.Name(), runner.TFConfigPath())

	return runner.WalkResourceAttributes(r.resourceType, r.attributeName, func(attribute *hcl.Attribute) error {
		var val string
		err := runner.EvaluateExpr(attribute.Expr, &val)

		return runner.EnsureNoError(err, func() error {
			found := false
			for _, item := range r.enum {
				if item == val {
					found = true
				}
			}
			if !found {
				runner.EmitIssue(
					r,
					fmt.Sprintf(`"%s" is an invalid value as behavior_on_mx_failure`, truncateLongMessage(val)),
					attribute.Expr.Range(),
				)
			}
			return nil
		})
	})
}
