// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"fmt"
	"log"

	hcl "github.com/hashicorp/hcl/v2"
	"github.com/terraform-linters/tflint/tflint"
)

// AwsSesIdentityNotificationTopicInvalidNotificationTypeRule checks the pattern is valid
type AwsSesIdentityNotificationTopicInvalidNotificationTypeRule struct {
	resourceType  string
	attributeName string
	enum          []string
}

// NewAwsSesIdentityNotificationTopicInvalidNotificationTypeRule returns new rule with default attributes
func NewAwsSesIdentityNotificationTopicInvalidNotificationTypeRule() *AwsSesIdentityNotificationTopicInvalidNotificationTypeRule {
	return &AwsSesIdentityNotificationTopicInvalidNotificationTypeRule{
		resourceType:  "aws_ses_identity_notification_topic",
		attributeName: "notification_type",
		enum: []string{
			"Bounce",
			"Complaint",
			"Delivery",
		},
	}
}

// Name returns the rule name
func (r *AwsSesIdentityNotificationTopicInvalidNotificationTypeRule) Name() string {
	return "aws_ses_identity_notification_topic_invalid_notification_type"
}

// Enabled returns whether the rule is enabled by default
func (r *AwsSesIdentityNotificationTopicInvalidNotificationTypeRule) Enabled() bool {
	return true
}

// Severity returns the rule severity
func (r *AwsSesIdentityNotificationTopicInvalidNotificationTypeRule) Severity() string {
	return tflint.ERROR
}

// Link returns the rule reference link
func (r *AwsSesIdentityNotificationTopicInvalidNotificationTypeRule) Link() string {
	return ""
}

// Check checks the pattern is valid
func (r *AwsSesIdentityNotificationTopicInvalidNotificationTypeRule) Check(runner *tflint.Runner) error {
	log.Printf("[TRACE] Check `%s` rule for `%s` runner", r.Name(), runner.TFConfigPath())

	return runner.WalkResourceAttributes(r.resourceType, r.attributeName, func(attribute *hcl.Attribute) error {
		var val string
		err := runner.EvaluateExpr(attribute.Expr, &val)

		return runner.EnsureNoError(err, func() error {
			found := false
			for _, item := range r.enum {
				if item == val {
					found = true
				}
			}
			if !found {
				runner.EmitIssue(
					r,
					fmt.Sprintf(`"%s" is an invalid value as notification_type`, truncateLongMessage(val)),
					attribute.Expr.Range(),
				)
			}
			return nil
		})
	})
}
