// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"log"

	hcl "github.com/hashicorp/hcl/v2"
	"github.com/terraform-linters/tflint/tflint"
)

// AwsSfnStateMachineInvalidDefinitionRule checks the pattern is valid
type AwsSfnStateMachineInvalidDefinitionRule struct {
	resourceType  string
	attributeName string
	max           int
	min           int
}

// NewAwsSfnStateMachineInvalidDefinitionRule returns new rule with default attributes
func NewAwsSfnStateMachineInvalidDefinitionRule() *AwsSfnStateMachineInvalidDefinitionRule {
	return &AwsSfnStateMachineInvalidDefinitionRule{
		resourceType:  "aws_sfn_state_machine",
		attributeName: "definition",
		max:           1048576,
		min:           1,
	}
}

// Name returns the rule name
func (r *AwsSfnStateMachineInvalidDefinitionRule) Name() string {
	return "aws_sfn_state_machine_invalid_definition"
}

// Enabled returns whether the rule is enabled by default
func (r *AwsSfnStateMachineInvalidDefinitionRule) Enabled() bool {
	return true
}

// Severity returns the rule severity
func (r *AwsSfnStateMachineInvalidDefinitionRule) Severity() string {
	return tflint.ERROR
}

// Link returns the rule reference link
func (r *AwsSfnStateMachineInvalidDefinitionRule) Link() string {
	return ""
}

// Check checks the pattern is valid
func (r *AwsSfnStateMachineInvalidDefinitionRule) Check(runner *tflint.Runner) error {
	log.Printf("[TRACE] Check `%s` rule for `%s` runner", r.Name(), runner.TFConfigPath())

	return runner.WalkResourceAttributes(r.resourceType, r.attributeName, func(attribute *hcl.Attribute) error {
		var val string
		err := runner.EvaluateExpr(attribute.Expr, &val)

		return runner.EnsureNoError(err, func() error {
			if len(val) > r.max {
				runner.EmitIssue(
					r,
					"definition must be 1048576 characters or less",
					attribute.Expr.Range(),
				)
			}
			if len(val) < r.min {
				runner.EmitIssue(
					r,
					"definition must be 1 characters or higher",
					attribute.Expr.Range(),
				)
			}
			return nil
		})
	})
}
