// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"fmt"
	"log"

	hcl "github.com/hashicorp/hcl/v2"
	"github.com/terraform-linters/tflint/tflint"
)

// AwsSpotFleetRequestInvalidFleetTypeRule checks the pattern is valid
type AwsSpotFleetRequestInvalidFleetTypeRule struct {
	resourceType  string
	attributeName string
	enum          []string
}

// NewAwsSpotFleetRequestInvalidFleetTypeRule returns new rule with default attributes
func NewAwsSpotFleetRequestInvalidFleetTypeRule() *AwsSpotFleetRequestInvalidFleetTypeRule {
	return &AwsSpotFleetRequestInvalidFleetTypeRule{
		resourceType:  "aws_spot_fleet_request",
		attributeName: "fleet_type",
		enum: []string{
			"request",
			"maintain",
			"instant",
		},
	}
}

// Name returns the rule name
func (r *AwsSpotFleetRequestInvalidFleetTypeRule) Name() string {
	return "aws_spot_fleet_request_invalid_fleet_type"
}

// Enabled returns whether the rule is enabled by default
func (r *AwsSpotFleetRequestInvalidFleetTypeRule) Enabled() bool {
	return true
}

// Severity returns the rule severity
func (r *AwsSpotFleetRequestInvalidFleetTypeRule) Severity() string {
	return tflint.ERROR
}

// Link returns the rule reference link
func (r *AwsSpotFleetRequestInvalidFleetTypeRule) Link() string {
	return ""
}

// Check checks the pattern is valid
func (r *AwsSpotFleetRequestInvalidFleetTypeRule) Check(runner *tflint.Runner) error {
	log.Printf("[TRACE] Check `%s` rule for `%s` runner", r.Name(), runner.TFConfigPath())

	return runner.WalkResourceAttributes(r.resourceType, r.attributeName, func(attribute *hcl.Attribute) error {
		var val string
		err := runner.EvaluateExpr(attribute.Expr, &val)

		return runner.EnsureNoError(err, func() error {
			found := false
			for _, item := range r.enum {
				if item == val {
					found = true
				}
			}
			if !found {
				runner.EmitIssue(
					r,
					fmt.Sprintf(`"%s" is an invalid value as fleet_type`, truncateLongMessage(val)),
					attribute.Expr.Range(),
				)
			}
			return nil
		})
	})
}
