// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"testing"

	"github.com/terraform-linters/tflint/tflint"
)

func Test_AwsSpotFleetRequestInvalidInstanceInterruptionBehaviourRule(t *testing.T) {
	cases := []struct {
		Name     string
		Content  string
		Expected tflint.Issues
	}{
		{
			Name: "It includes invalid characters",
			Content: `
resource "aws_spot_fleet_request" "foo" {
	instance_interruption_behaviour = "restart"
}`,
			Expected: tflint.Issues{
				{
					Rule:    NewAwsSpotFleetRequestInvalidInstanceInterruptionBehaviourRule(),
					Message: `"restart" is an invalid value as instance_interruption_behaviour`,
				},
			},
		},
		{
			Name: "It is valid",
			Content: `
resource "aws_spot_fleet_request" "foo" {
	instance_interruption_behaviour = "hibernate"
}`,
			Expected: tflint.Issues{},
		},
	}

	rule := NewAwsSpotFleetRequestInvalidInstanceInterruptionBehaviourRule()

	for _, tc := range cases {
		runner := tflint.TestRunner(t, map[string]string{"resource.tf": tc.Content})

		if err := rule.Check(runner); err != nil {
			t.Fatalf("Unexpected error occurred: %s", err)
		}

		tflint.AssertIssuesWithoutRange(t, tc.Expected, runner.Issues)
	}
}
