// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"fmt"
	"log"

	hcl "github.com/hashicorp/hcl/v2"
	"github.com/terraform-linters/tflint/tflint"
)

// AwsSpotInstanceRequestInvalidInstanceInterruptionBehaviourRule checks the pattern is valid
type AwsSpotInstanceRequestInvalidInstanceInterruptionBehaviourRule struct {
	resourceType  string
	attributeName string
	enum          []string
}

// NewAwsSpotInstanceRequestInvalidInstanceInterruptionBehaviourRule returns new rule with default attributes
func NewAwsSpotInstanceRequestInvalidInstanceInterruptionBehaviourRule() *AwsSpotInstanceRequestInvalidInstanceInterruptionBehaviourRule {
	return &AwsSpotInstanceRequestInvalidInstanceInterruptionBehaviourRule{
		resourceType:  "aws_spot_instance_request",
		attributeName: "instance_interruption_behaviour",
		enum: []string{
			"hibernate",
			"stop",
			"terminate",
		},
	}
}

// Name returns the rule name
func (r *AwsSpotInstanceRequestInvalidInstanceInterruptionBehaviourRule) Name() string {
	return "aws_spot_instance_request_invalid_instance_interruption_behaviour"
}

// Enabled returns whether the rule is enabled by default
func (r *AwsSpotInstanceRequestInvalidInstanceInterruptionBehaviourRule) Enabled() bool {
	return true
}

// Severity returns the rule severity
func (r *AwsSpotInstanceRequestInvalidInstanceInterruptionBehaviourRule) Severity() string {
	return tflint.ERROR
}

// Link returns the rule reference link
func (r *AwsSpotInstanceRequestInvalidInstanceInterruptionBehaviourRule) Link() string {
	return ""
}

// Check checks the pattern is valid
func (r *AwsSpotInstanceRequestInvalidInstanceInterruptionBehaviourRule) Check(runner *tflint.Runner) error {
	log.Printf("[TRACE] Check `%s` rule for `%s` runner", r.Name(), runner.TFConfigPath())

	return runner.WalkResourceAttributes(r.resourceType, r.attributeName, func(attribute *hcl.Attribute) error {
		var val string
		err := runner.EvaluateExpr(attribute.Expr, &val)

		return runner.EnsureNoError(err, func() error {
			found := false
			for _, item := range r.enum {
				if item == val {
					found = true
				}
			}
			if !found {
				runner.EmitIssue(
					r,
					fmt.Sprintf(`"%s" is an invalid value as instance_interruption_behaviour`, truncateLongMessage(val)),
					attribute.Expr.Range(),
				)
			}
			return nil
		})
	})
}
