// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"fmt"
	"log"

	hcl "github.com/hashicorp/hcl/v2"
	"github.com/terraform-linters/tflint/tflint"
)

// AwsSsmAssociationInvalidComplianceSeverityRule checks the pattern is valid
type AwsSsmAssociationInvalidComplianceSeverityRule struct {
	resourceType  string
	attributeName string
	enum          []string
}

// NewAwsSsmAssociationInvalidComplianceSeverityRule returns new rule with default attributes
func NewAwsSsmAssociationInvalidComplianceSeverityRule() *AwsSsmAssociationInvalidComplianceSeverityRule {
	return &AwsSsmAssociationInvalidComplianceSeverityRule{
		resourceType:  "aws_ssm_association",
		attributeName: "compliance_severity",
		enum: []string{
			"CRITICAL",
			"HIGH",
			"MEDIUM",
			"LOW",
			"UNSPECIFIED",
		},
	}
}

// Name returns the rule name
func (r *AwsSsmAssociationInvalidComplianceSeverityRule) Name() string {
	return "aws_ssm_association_invalid_compliance_severity"
}

// Enabled returns whether the rule is enabled by default
func (r *AwsSsmAssociationInvalidComplianceSeverityRule) Enabled() bool {
	return true
}

// Severity returns the rule severity
func (r *AwsSsmAssociationInvalidComplianceSeverityRule) Severity() string {
	return tflint.ERROR
}

// Link returns the rule reference link
func (r *AwsSsmAssociationInvalidComplianceSeverityRule) Link() string {
	return ""
}

// Check checks the pattern is valid
func (r *AwsSsmAssociationInvalidComplianceSeverityRule) Check(runner *tflint.Runner) error {
	log.Printf("[TRACE] Check `%s` rule for `%s` runner", r.Name(), runner.TFConfigPath())

	return runner.WalkResourceAttributes(r.resourceType, r.attributeName, func(attribute *hcl.Attribute) error {
		var val string
		err := runner.EvaluateExpr(attribute.Expr, &val)

		return runner.EnsureNoError(err, func() error {
			found := false
			for _, item := range r.enum {
				if item == val {
					found = true
				}
			}
			if !found {
				runner.EmitIssue(
					r,
					fmt.Sprintf(`"%s" is an invalid value as compliance_severity`, truncateLongMessage(val)),
					attribute.Expr.Range(),
				)
			}
			return nil
		})
	})
}
