// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"fmt"
	"log"

	hcl "github.com/hashicorp/hcl/v2"
	"github.com/terraform-linters/tflint/tflint"
)

// AwsSsmMaintenanceWindowTargetInvalidResourceTypeRule checks the pattern is valid
type AwsSsmMaintenanceWindowTargetInvalidResourceTypeRule struct {
	resourceType  string
	attributeName string
	enum          []string
}

// NewAwsSsmMaintenanceWindowTargetInvalidResourceTypeRule returns new rule with default attributes
func NewAwsSsmMaintenanceWindowTargetInvalidResourceTypeRule() *AwsSsmMaintenanceWindowTargetInvalidResourceTypeRule {
	return &AwsSsmMaintenanceWindowTargetInvalidResourceTypeRule{
		resourceType:  "aws_ssm_maintenance_window_target",
		attributeName: "resource_type",
		enum: []string{
			"INSTANCE",
			"RESOURCE_GROUP",
		},
	}
}

// Name returns the rule name
func (r *AwsSsmMaintenanceWindowTargetInvalidResourceTypeRule) Name() string {
	return "aws_ssm_maintenance_window_target_invalid_resource_type"
}

// Enabled returns whether the rule is enabled by default
func (r *AwsSsmMaintenanceWindowTargetInvalidResourceTypeRule) Enabled() bool {
	return true
}

// Severity returns the rule severity
func (r *AwsSsmMaintenanceWindowTargetInvalidResourceTypeRule) Severity() string {
	return tflint.ERROR
}

// Link returns the rule reference link
func (r *AwsSsmMaintenanceWindowTargetInvalidResourceTypeRule) Link() string {
	return ""
}

// Check checks the pattern is valid
func (r *AwsSsmMaintenanceWindowTargetInvalidResourceTypeRule) Check(runner *tflint.Runner) error {
	log.Printf("[TRACE] Check `%s` rule for `%s` runner", r.Name(), runner.TFConfigPath())

	return runner.WalkResourceAttributes(r.resourceType, r.attributeName, func(attribute *hcl.Attribute) error {
		var val string
		err := runner.EvaluateExpr(attribute.Expr, &val)

		return runner.EnsureNoError(err, func() error {
			found := false
			for _, item := range r.enum {
				if item == val {
					found = true
				}
			}
			if !found {
				runner.EmitIssue(
					r,
					fmt.Sprintf(`"%s" is an invalid value as resource_type`, truncateLongMessage(val)),
					attribute.Expr.Range(),
				)
			}
			return nil
		})
	})
}
