// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"fmt"
	"log"

	hcl "github.com/hashicorp/hcl/v2"
	"github.com/terraform-linters/tflint/tflint"
)

// AwsSsmMaintenanceWindowTaskInvalidTaskTypeRule checks the pattern is valid
type AwsSsmMaintenanceWindowTaskInvalidTaskTypeRule struct {
	resourceType  string
	attributeName string
	enum          []string
}

// NewAwsSsmMaintenanceWindowTaskInvalidTaskTypeRule returns new rule with default attributes
func NewAwsSsmMaintenanceWindowTaskInvalidTaskTypeRule() *AwsSsmMaintenanceWindowTaskInvalidTaskTypeRule {
	return &AwsSsmMaintenanceWindowTaskInvalidTaskTypeRule{
		resourceType:  "aws_ssm_maintenance_window_task",
		attributeName: "task_type",
		enum: []string{
			"RUN_COMMAND",
			"AUTOMATION",
			"STEP_FUNCTIONS",
			"LAMBDA",
		},
	}
}

// Name returns the rule name
func (r *AwsSsmMaintenanceWindowTaskInvalidTaskTypeRule) Name() string {
	return "aws_ssm_maintenance_window_task_invalid_task_type"
}

// Enabled returns whether the rule is enabled by default
func (r *AwsSsmMaintenanceWindowTaskInvalidTaskTypeRule) Enabled() bool {
	return true
}

// Severity returns the rule severity
func (r *AwsSsmMaintenanceWindowTaskInvalidTaskTypeRule) Severity() string {
	return tflint.ERROR
}

// Link returns the rule reference link
func (r *AwsSsmMaintenanceWindowTaskInvalidTaskTypeRule) Link() string {
	return ""
}

// Check checks the pattern is valid
func (r *AwsSsmMaintenanceWindowTaskInvalidTaskTypeRule) Check(runner *tflint.Runner) error {
	log.Printf("[TRACE] Check `%s` rule for `%s` runner", r.Name(), runner.TFConfigPath())

	return runner.WalkResourceAttributes(r.resourceType, r.attributeName, func(attribute *hcl.Attribute) error {
		var val string
		err := runner.EvaluateExpr(attribute.Expr, &val)

		return runner.EnsureNoError(err, func() error {
			found := false
			for _, item := range r.enum {
				if item == val {
					found = true
				}
			}
			if !found {
				runner.EmitIssue(
					r,
					fmt.Sprintf(`"%s" is an invalid value as task_type`, truncateLongMessage(val)),
					attribute.Expr.Range(),
				)
			}
			return nil
		})
	})
}
