// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"fmt"
	"log"
	"regexp"

	hcl "github.com/hashicorp/hcl/v2"
	"github.com/terraform-linters/tflint/tflint"
)

// AwsSsmPatchGroupInvalidBaselineIDRule checks the pattern is valid
type AwsSsmPatchGroupInvalidBaselineIDRule struct {
	resourceType  string
	attributeName string
	max           int
	min           int
	pattern       *regexp.Regexp
}

// NewAwsSsmPatchGroupInvalidBaselineIDRule returns new rule with default attributes
func NewAwsSsmPatchGroupInvalidBaselineIDRule() *AwsSsmPatchGroupInvalidBaselineIDRule {
	return &AwsSsmPatchGroupInvalidBaselineIDRule{
		resourceType:  "aws_ssm_patch_group",
		attributeName: "baseline_id",
		max:           128,
		min:           20,
		pattern:       regexp.MustCompile(`^[a-zA-Z0-9_\-:/]{20,128}$`),
	}
}

// Name returns the rule name
func (r *AwsSsmPatchGroupInvalidBaselineIDRule) Name() string {
	return "aws_ssm_patch_group_invalid_baseline_id"
}

// Enabled returns whether the rule is enabled by default
func (r *AwsSsmPatchGroupInvalidBaselineIDRule) Enabled() bool {
	return true
}

// Severity returns the rule severity
func (r *AwsSsmPatchGroupInvalidBaselineIDRule) Severity() string {
	return tflint.ERROR
}

// Link returns the rule reference link
func (r *AwsSsmPatchGroupInvalidBaselineIDRule) Link() string {
	return ""
}

// Check checks the pattern is valid
func (r *AwsSsmPatchGroupInvalidBaselineIDRule) Check(runner *tflint.Runner) error {
	log.Printf("[TRACE] Check `%s` rule for `%s` runner", r.Name(), runner.TFConfigPath())

	return runner.WalkResourceAttributes(r.resourceType, r.attributeName, func(attribute *hcl.Attribute) error {
		var val string
		err := runner.EvaluateExpr(attribute.Expr, &val)

		return runner.EnsureNoError(err, func() error {
			if len(val) > r.max {
				runner.EmitIssue(
					r,
					"baseline_id must be 128 characters or less",
					attribute.Expr.Range(),
				)
			}
			if len(val) < r.min {
				runner.EmitIssue(
					r,
					"baseline_id must be 20 characters or higher",
					attribute.Expr.Range(),
				)
			}
			if !r.pattern.MatchString(val) {
				runner.EmitIssue(
					r,
					fmt.Sprintf(`"%s" does not match valid pattern %s`, truncateLongMessage(val), `^[a-zA-Z0-9_\-:/]{20,128}$`),
					attribute.Expr.Range(),
				)
			}
			return nil
		})
	})
}
