// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"fmt"
	"log"
	"regexp"

	hcl "github.com/hashicorp/hcl/v2"
	"github.com/terraform-linters/tflint/tflint"
)

// AwsStoragegatewayNfsFileShareInvalidKmsKeyArnRule checks the pattern is valid
type AwsStoragegatewayNfsFileShareInvalidKmsKeyArnRule struct {
	resourceType  string
	attributeName string
	max           int
	min           int
	pattern       *regexp.Regexp
}

// NewAwsStoragegatewayNfsFileShareInvalidKmsKeyArnRule returns new rule with default attributes
func NewAwsStoragegatewayNfsFileShareInvalidKmsKeyArnRule() *AwsStoragegatewayNfsFileShareInvalidKmsKeyArnRule {
	return &AwsStoragegatewayNfsFileShareInvalidKmsKeyArnRule{
		resourceType:  "aws_storagegateway_nfs_file_share",
		attributeName: "kms_key_arn",
		max:           2048,
		min:           7,
		pattern:       regexp.MustCompile(`^(^arn:(aws|aws-cn|aws-us-gov):kms:([a-zA-Z0-9-]+):([0-9]+):(key|alias)/(\S+)$)|(^alias/(\S+)$)$`),
	}
}

// Name returns the rule name
func (r *AwsStoragegatewayNfsFileShareInvalidKmsKeyArnRule) Name() string {
	return "aws_storagegateway_nfs_file_share_invalid_kms_key_arn"
}

// Enabled returns whether the rule is enabled by default
func (r *AwsStoragegatewayNfsFileShareInvalidKmsKeyArnRule) Enabled() bool {
	return true
}

// Severity returns the rule severity
func (r *AwsStoragegatewayNfsFileShareInvalidKmsKeyArnRule) Severity() string {
	return tflint.ERROR
}

// Link returns the rule reference link
func (r *AwsStoragegatewayNfsFileShareInvalidKmsKeyArnRule) Link() string {
	return ""
}

// Check checks the pattern is valid
func (r *AwsStoragegatewayNfsFileShareInvalidKmsKeyArnRule) Check(runner *tflint.Runner) error {
	log.Printf("[TRACE] Check `%s` rule for `%s` runner", r.Name(), runner.TFConfigPath())

	return runner.WalkResourceAttributes(r.resourceType, r.attributeName, func(attribute *hcl.Attribute) error {
		var val string
		err := runner.EvaluateExpr(attribute.Expr, &val)

		return runner.EnsureNoError(err, func() error {
			if len(val) > r.max {
				runner.EmitIssue(
					r,
					"kms_key_arn must be 2048 characters or less",
					attribute.Expr.Range(),
				)
			}
			if len(val) < r.min {
				runner.EmitIssue(
					r,
					"kms_key_arn must be 7 characters or higher",
					attribute.Expr.Range(),
				)
			}
			if !r.pattern.MatchString(val) {
				runner.EmitIssue(
					r,
					fmt.Sprintf(`"%s" does not match valid pattern %s`, truncateLongMessage(val), `^(^arn:(aws|aws-cn|aws-us-gov):kms:([a-zA-Z0-9-]+):([0-9]+):(key|alias)/(\S+)$)|(^alias/(\S+)$)$`),
					attribute.Expr.Range(),
				)
			}
			return nil
		})
	})
}
