// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"log"

	hcl "github.com/hashicorp/hcl/v2"
	"github.com/terraform-linters/tflint/tflint"
)

// AwsTransferUserInvalidPolicyRule checks the pattern is valid
type AwsTransferUserInvalidPolicyRule struct {
	resourceType  string
	attributeName string
	max           int
}

// NewAwsTransferUserInvalidPolicyRule returns new rule with default attributes
func NewAwsTransferUserInvalidPolicyRule() *AwsTransferUserInvalidPolicyRule {
	return &AwsTransferUserInvalidPolicyRule{
		resourceType:  "aws_transfer_user",
		attributeName: "policy",
		max:           2048,
	}
}

// Name returns the rule name
func (r *AwsTransferUserInvalidPolicyRule) Name() string {
	return "aws_transfer_user_invalid_policy"
}

// Enabled returns whether the rule is enabled by default
func (r *AwsTransferUserInvalidPolicyRule) Enabled() bool {
	return true
}

// Severity returns the rule severity
func (r *AwsTransferUserInvalidPolicyRule) Severity() string {
	return tflint.ERROR
}

// Link returns the rule reference link
func (r *AwsTransferUserInvalidPolicyRule) Link() string {
	return ""
}

// Check checks the pattern is valid
func (r *AwsTransferUserInvalidPolicyRule) Check(runner *tflint.Runner) error {
	log.Printf("[TRACE] Check `%s` rule for `%s` runner", r.Name(), runner.TFConfigPath())

	return runner.WalkResourceAttributes(r.resourceType, r.attributeName, func(attribute *hcl.Attribute) error {
		var val string
		err := runner.EvaluateExpr(attribute.Expr, &val)

		return runner.EnsureNoError(err, func() error {
			if len(val) > r.max {
				runner.EmitIssue(
					r,
					"policy must be 2048 characters or less",
					attribute.Expr.Range(),
				)
			}
			return nil
		})
	})
}
