// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"fmt"
	"log"
	"regexp"

	hcl "github.com/hashicorp/hcl/v2"
	"github.com/terraform-linters/tflint/tflint"
)

// AwsTransferUserInvalidServerIDRule checks the pattern is valid
type AwsTransferUserInvalidServerIDRule struct {
	resourceType  string
	attributeName string
	max           int
	min           int
	pattern       *regexp.Regexp
}

// NewAwsTransferUserInvalidServerIDRule returns new rule with default attributes
func NewAwsTransferUserInvalidServerIDRule() *AwsTransferUserInvalidServerIDRule {
	return &AwsTransferUserInvalidServerIDRule{
		resourceType:  "aws_transfer_user",
		attributeName: "server_id",
		max:           19,
		min:           19,
		pattern:       regexp.MustCompile(`^s-([0-9a-f]{17})$`),
	}
}

// Name returns the rule name
func (r *AwsTransferUserInvalidServerIDRule) Name() string {
	return "aws_transfer_user_invalid_server_id"
}

// Enabled returns whether the rule is enabled by default
func (r *AwsTransferUserInvalidServerIDRule) Enabled() bool {
	return true
}

// Severity returns the rule severity
func (r *AwsTransferUserInvalidServerIDRule) Severity() string {
	return tflint.ERROR
}

// Link returns the rule reference link
func (r *AwsTransferUserInvalidServerIDRule) Link() string {
	return ""
}

// Check checks the pattern is valid
func (r *AwsTransferUserInvalidServerIDRule) Check(runner *tflint.Runner) error {
	log.Printf("[TRACE] Check `%s` rule for `%s` runner", r.Name(), runner.TFConfigPath())

	return runner.WalkResourceAttributes(r.resourceType, r.attributeName, func(attribute *hcl.Attribute) error {
		var val string
		err := runner.EvaluateExpr(attribute.Expr, &val)

		return runner.EnsureNoError(err, func() error {
			if len(val) > r.max {
				runner.EmitIssue(
					r,
					"server_id must be 19 characters or less",
					attribute.Expr.Range(),
				)
			}
			if len(val) < r.min {
				runner.EmitIssue(
					r,
					"server_id must be 19 characters or higher",
					attribute.Expr.Range(),
				)
			}
			if !r.pattern.MatchString(val) {
				runner.EmitIssue(
					r,
					fmt.Sprintf(`"%s" does not match valid pattern %s`, truncateLongMessage(val), `^s-([0-9a-f]{17})$`),
					attribute.Expr.Range(),
				)
			}
			return nil
		})
	})
}
