// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"fmt"
	"log"
	"regexp"

	hcl "github.com/hashicorp/hcl/v2"
	"github.com/terraform-linters/tflint/tflint"
)

// AwsTransferUserInvalidUserNameRule checks the pattern is valid
type AwsTransferUserInvalidUserNameRule struct {
	resourceType  string
	attributeName string
	max           int
	min           int
	pattern       *regexp.Regexp
}

// NewAwsTransferUserInvalidUserNameRule returns new rule with default attributes
func NewAwsTransferUserInvalidUserNameRule() *AwsTransferUserInvalidUserNameRule {
	return &AwsTransferUserInvalidUserNameRule{
		resourceType:  "aws_transfer_user",
		attributeName: "user_name",
		max:           100,
		min:           3,
		pattern:       regexp.MustCompile(`^[\w][\w@.-]{2,99}$`),
	}
}

// Name returns the rule name
func (r *AwsTransferUserInvalidUserNameRule) Name() string {
	return "aws_transfer_user_invalid_user_name"
}

// Enabled returns whether the rule is enabled by default
func (r *AwsTransferUserInvalidUserNameRule) Enabled() bool {
	return true
}

// Severity returns the rule severity
func (r *AwsTransferUserInvalidUserNameRule) Severity() string {
	return tflint.ERROR
}

// Link returns the rule reference link
func (r *AwsTransferUserInvalidUserNameRule) Link() string {
	return ""
}

// Check checks the pattern is valid
func (r *AwsTransferUserInvalidUserNameRule) Check(runner *tflint.Runner) error {
	log.Printf("[TRACE] Check `%s` rule for `%s` runner", r.Name(), runner.TFConfigPath())

	return runner.WalkResourceAttributes(r.resourceType, r.attributeName, func(attribute *hcl.Attribute) error {
		var val string
		err := runner.EvaluateExpr(attribute.Expr, &val)

		return runner.EnsureNoError(err, func() error {
			if len(val) > r.max {
				runner.EmitIssue(
					r,
					"user_name must be 100 characters or less",
					attribute.Expr.Range(),
				)
			}
			if len(val) < r.min {
				runner.EmitIssue(
					r,
					"user_name must be 3 characters or higher",
					attribute.Expr.Range(),
				)
			}
			if !r.pattern.MatchString(val) {
				runner.EmitIssue(
					r,
					fmt.Sprintf(`"%s" does not match valid pattern %s`, truncateLongMessage(val), `^[\w][\w@.-]{2,99}$`),
					attribute.Expr.Range(),
				)
			}
			return nil
		})
	})
}
