// This file generated by `generator/`. DO NOT EDIT

package models

import (
	"fmt"
	"log"
	"regexp"

	hcl "github.com/hashicorp/hcl/v2"
	"github.com/terraform-linters/tflint/tflint"
)

// AwsWorklinkFleetInvalidAuditStreamArnRule checks the pattern is valid
type AwsWorklinkFleetInvalidAuditStreamArnRule struct {
	resourceType  string
	attributeName string
	pattern       *regexp.Regexp
}

// NewAwsWorklinkFleetInvalidAuditStreamArnRule returns new rule with default attributes
func NewAwsWorklinkFleetInvalidAuditStreamArnRule() *AwsWorklinkFleetInvalidAuditStreamArnRule {
	return &AwsWorklinkFleetInvalidAuditStreamArnRule{
		resourceType:  "aws_worklink_fleet",
		attributeName: "audit_stream_arn",
		pattern:       regexp.MustCompile(`^arn:aws:kinesis:.+:[0-9]{12}:stream/AmazonWorkLink-.*$`),
	}
}

// Name returns the rule name
func (r *AwsWorklinkFleetInvalidAuditStreamArnRule) Name() string {
	return "aws_worklink_fleet_invalid_audit_stream_arn"
}

// Enabled returns whether the rule is enabled by default
func (r *AwsWorklinkFleetInvalidAuditStreamArnRule) Enabled() bool {
	return true
}

// Severity returns the rule severity
func (r *AwsWorklinkFleetInvalidAuditStreamArnRule) Severity() string {
	return tflint.ERROR
}

// Link returns the rule reference link
func (r *AwsWorklinkFleetInvalidAuditStreamArnRule) Link() string {
	return ""
}

// Check checks the pattern is valid
func (r *AwsWorklinkFleetInvalidAuditStreamArnRule) Check(runner *tflint.Runner) error {
	log.Printf("[TRACE] Check `%s` rule for `%s` runner", r.Name(), runner.TFConfigPath())

	return runner.WalkResourceAttributes(r.resourceType, r.attributeName, func(attribute *hcl.Attribute) error {
		var val string
		err := runner.EvaluateExpr(attribute.Expr, &val)

		return runner.EnsureNoError(err, func() error {
			if !r.pattern.MatchString(val) {
				runner.EmitIssue(
					r,
					fmt.Sprintf(`"%s" does not match valid pattern %s`, truncateLongMessage(val), `^arn:aws:kinesis:.+:[0-9]{12}:stream/AmazonWorkLink-.*$`),
					attribute.Expr.Range(),
				)
			}
			return nil
		})
	})
}
